package icontrols.DataGrid;

import com.ms.ado.DataSource;
import com.ms.ado.Field;
import com.ms.ado.RecordsetEvent;
import com.ms.dll.DllLib;
import com.ms.wd.app.Message;
import com.ms.wd.core.CancelEvent;
import com.ms.wd.core.CancelEventHandler;
import com.ms.wd.core.Closure;
import com.ms.wd.core.Event;
import com.ms.wd.core.EventHandler;
import com.ms.wd.ui.Brush;
import com.ms.wd.ui.Color;
import com.ms.wd.ui.Control;
import com.ms.wd.ui.Cursor;
import com.ms.wd.ui.Font;
import com.ms.wd.ui.Graphics;
import com.ms.wd.ui.HScrollBar;
import com.ms.wd.ui.MouseEvent;
import com.ms.wd.ui.PaintEvent;
import com.ms.wd.ui.Pen;
import com.ms.wd.ui.Rectangle;
import com.ms.wd.ui.ScrollBar;
import com.ms.wd.ui.ScrollEvent;
import com.ms.wd.ui.ScrollEventHandler;
import com.ms.wd.ui.VScrollBar;
import com.ms.wd.util.Debug;
import com.ms.wd.util.Root;
import com.ms.wd.win32.RECT;
import com.ms.wd.win32.TEXTMETRIC;
import com.ms.wd.win32.Windows;
import icontrols.BorderDisplayer;
import icontrols.Data.DataProvider;
import icontrols.Data.DataRow;
import icontrols.Data.IDataConsumer;
import icontrols.Data.RecordsetProvider;

public class DataGrid extends Control implements IDataConsumer {
   protected static final int LOCT_AREA_COLUMNHEADER = 1;
   protected static final int LOCT_AREA_ROWSELECTOR = 2;
   protected static final int LOCT_AREA_GRID = 4;
   protected static final int LOCT_AREA_SCROLL = 8;
   protected static final int LOCT_AREA_BORDER = 16;
   protected static final int LOCT_AREA_BLANK = 32;
   protected static final int LOCT_AREA_PHANTOMROW = 64;
   protected static final int LOCT_AREA_GRIDLINE = 128;
   protected static final int LOCT_AREA_CAPTION = 256;
   protected static final int LOCT_VERTRESIZELINE = 65536;
   protected static final int LOCT_HORIZRESIZELINE = 131072;
   protected static final int LOCT_CENTER = 262144;
   private static final int RESIZE_START = -1;
   private static final int RESIZE_END = -2;
   private static final int RESIZE_CONTINUE = -3;
   protected static final int MIN_COLUMN_WIDTH = 15;
   protected static final int MIN_ROW_HEIGHT = 15;
   private int m_displayRowCount = -1;
   private int m_phantomRowDisplayIndex = -1;
   private DataRow m_editRowRef = null;
   private DataRow m_currentRowRef = null;
   private int m_currentColumn = -1;
   private DataRow m_lastRow = null;
   private DataRow m_lastRowRef = null;
   private int m_lastColumn = -1;
   private GridCell m_hotCell = new GridCell(this);
   private GridCell m_marqueeCell = new GridCell(this);
   private int m_lastVisibleColumn = -1;
   private int m_firstVisibleColumn = -1;
   private boolean m_internalRowReposition = false;
   boolean m_showPhantomRow = true;
   private int m_borderStyle = 2;
   private Font m_headerFont = null;
   private int m_gridLineStyle = 1;
   private String m_caption = null;
   private boolean m_showColumnHeaders = true;
   private int m_defaultColumnWidth = 75;
   private boolean m_allowArrows = true;
   private int m_tabAction = 0;
   private int m_enterAction = 0;
   private boolean m_wrapCellPointer = false;
   private Object m_tag = null;
   private Color m_selectedForeColor;
   private Color m_selectedBackColor;
   private int m_headerLineCount;
   private boolean m_allowDelete;
   boolean m_allowRowSizing;
   private boolean m_allowUpdate;
   private boolean m_showRowSelectors;
   private boolean m_showVertScrollbar;
   private boolean m_showHorizScrollbar;
   private boolean m_holdColumns;
   Column[] m_columns;
   int m_columnCount;
   private ScrollBar m_horizScrollbar;
   private ScrollBar m_vertScrollbar;
   private ColumnHeaderDisplayer m_captionDisplayer;
   private RowSelectorDrawEventHandler m_rowSelectorDraw;
   private RowSelectorDisplayer m_rowSelectorDisplayer;
   GridLineDisplayer m_gridLinesDisplayer;
   BorderDisplayer m_borderDisplayer;
   private Rectangle m_clientRect;
   private Rectangle m_clientRectInside;
   private Rectangle m_resizeBoxRect;
   private Brush m_controlBrush;
   private Brush m_unusedAreaBrush;
   int m_rowHeight;
   private int m_columnHeaderHeight;
   private int m_rowSelectorWidth;
   private int m_horizOffset;
   private Rectangle m_clipRect;
   private boolean m_pendingInvalidate;
   DataProvider m_dataProvider;
   private RecordsetProvider m_recordsetProvider;
   private int m_dataProviderAsyncMessage;
   private ICellEditor m_editorCurrent;
   private int m_editorDefaultWndProc;
   private int m_editorNewWndProc;
   private ICellEditor m_editorSubclassed;
   private boolean m_trackingResize;
   private int m_columnResizing;
   private int m_trackXStart;
   private int m_trackYStart;
   private int m_lastDrawLoc;
   private Selection m_selection;
   private boolean m_trackingDrag;
   private int m_dragColumnStart;
   private DataRow m_dragRowStart;
   private int m_dragColumnLast;
   private DataRow m_dragRowLast;
   private int m_lastX;
   private int m_lastY;
   private ColumnEventHandler m_afterColumnEditHandler;
   private ColumnEventHandler m_afterColumnUpdateHandler;
   private EventHandler m_afterDeleteHandler;
   private EventHandler m_afterInsertHandler;
   private EventHandler m_afterUpdateHandler;
   private BeforeColumnEditEventHandler m_beforeColumnEditHandler;
   private BeforeColumnUpdateEventHandler m_beforeColumnUpdateHandler;
   private CancelEventHandler m_beforeDeleteHandler;
   private CancelEventHandler m_beforeInsertHandler;
   private CancelEventHandler m_beforeUpdateHandler;
   private EventHandler m_changeHandler;
   private ColumnEventHandler m_columnEditHandler;
   private ColumnResizeEventHandler m_columnResizeHandler;
   private ErrorEventHandler m_errorHandler;
   private ColumnEventHandler m_headerClickHandler;
   private EventHandler m_addNewHandler;
   private ColumnRowChangeEventHandler m_columnRowChangeHandler;
   private CancelEventHandler m_rowResizeHandler;
   private CancelEventHandler m_scrollHandler;
   private CancelEventHandler m_selChangeHandler;
   private CancelEventHandler m_validateHandler;
   private int m_mouseWheelDelta;

   public DataSource getDataSource() {
      return this.m_recordsetProvider.getDataSource();
   }

   public void setDataSource(DataSource dataSource) {
      this.m_recordsetProvider.setDataSource(dataSource);
   }

   protected void onMouseWheel(MouseEvent event) {
      if (((Control)this).getEnabled()) {
         this.m_mouseWheelDelta += event.delta;
         int lines = 3 * this.m_mouseWheelDelta / 120;
         if (lines > 0 && this.m_dataProvider != null) {
            this.m_dataProvider.scroll(lines, this.m_dataProvider.getDisplayRow(0).getBookmark());
            this.m_mouseWheelDelta = 0;
         }

      }
   }

   public void acquireRecordset(Object sender, Event event) {
      this.removeEditor(true);
      this.m_dataProvider = new DataProvider(this.m_recordsetProvider.getRecordset());
      this.m_dataProvider.setDataConsumer(this);
      if (this.m_columnCount <= 0) {
         this.m_columnCount = this.m_dataProvider.getColumnCount();
         this.m_columns = new Column[this.m_columnCount];
         int nOffset = this.m_columnCount - 1;

         for(int i = 0; i < this.m_columnCount; ++i) {
            try {
               Field field = this.m_dataProvider.getReadField(i);
               String name = field.getName();
               this.m_columns[nOffset - i] = new Column(this, name);
               this.m_columns[nOffset - i].m_dbColumnId = i;
               this.m_columns[nOffset - i].m_width = this.m_defaultColumnWidth;
               this.m_columns[nOffset - i].internalSetIndex(nOffset - i);
            } catch (Exception e) {
               ((Throwable)e).printStackTrace();
            }
         }
      } else {
         for(int i = 0; i < this.m_columnCount; ++i) {
            this.m_columns[i].rebind();
         }
      }

      this.doLayout();
      this.invalidate();
      this.m_currentColumn = this.getFirstVisibleColumn();
      this.setCurrentColumnRow(this.m_currentColumn, this.m_dataProvider.getCurrentRow());
      this.m_holdColumns = false;
   }

   public void releaseRecordset(Object sender, Event event) {
      if (this.m_dataProvider != null) {
         this.removeEditor(true);
         this.m_dataProvider.setDataConsumer((IDataConsumer)null);
         this.m_dataProvider = null;
         if (!this.m_holdColumns) {
            this.m_columnCount = 0;
            this.m_columns = null;
         }

         this.m_editRowRef = null;
         this.m_currentRowRef = null;
         this.m_currentColumn = -1;
         this.m_lastRow = null;
         this.m_lastColumn = -1;
         this.m_hotCell = new GridCell(this);
         this.m_marqueeCell = new GridCell(this);
         this.m_selection = new Selection();
         this.doLayout();
         this.invalidate();
      }

   }

   public void addOnAfterInsert(EventHandler handler) {
      this.m_afterInsertHandler = (EventHandler)Closure.combine(handler, this.m_afterInsertHandler);
   }

   public void removeOnBeforeInsert(CancelEventHandler handler) {
      this.m_beforeInsertHandler = (CancelEventHandler)Closure.remove(this.m_beforeInsertHandler, handler);
   }

   private void endColumnRowChange() {
      int oldColumn = this.m_lastColumn;
      int column = this.m_currentColumn;
      DataRow oldRow = this.m_lastRowRef;
      DataRow row = this.m_currentRowRef;
      Debug.assert(this.m_dataProvider != null, "endColumnRowChange with no data");
      if (oldColumn != column || !DataProvider.rowsEqual(oldRow, row)) {
         ColumnRowChangeEvent event = null;
         if (oldRow != null) {
            event = new ColumnRowChangeEvent(oldColumn, oldRow.getBookmark());
         } else {
            event = new ColumnRowChangeEvent(oldColumn, (Object)null);
         }

         this.onColumnRowChange(event);
         this.setMarqueePosition(new GridCell(this, column, row));
         this.invalidateRowSelector(row);
         this.invalidateRowSelector(oldRow);
      }

      this.m_internalRowReposition = false;
   }

   protected Rectangle getCachedClientInsideRect() {
      if (this.m_clientRectInside == null) {
         Rectangle rectGarbage = this.getCachedClientRect();
      }

      Debug.assert(this.m_clientRectInside != null, "m_clientRectInside can't be null");
      return this.m_clientRectInside;
   }

   protected int getColumnHeaderHeight() {
      if (this.m_showColumnHeaders) {
         if (this.m_columnHeaderHeight < 0) {
            this.calcHeaderHeight();
         }

         return this.m_columnHeaderHeight;
      } else {
         return 0;
      }
   }

   public void addOnColumnRowChange(ColumnRowChangeEventHandler handler) {
      this.m_columnRowChangeHandler = (ColumnRowChangeEventHandler)Closure.combine(handler, this.m_columnRowChangeHandler);
   }

   public void addOnSelChange(CancelEventHandler handler) {
      this.m_selChangeHandler = (CancelEventHandler)Closure.combine(handler, this.m_selChangeHandler);
   }

   public void removeOnChange(EventHandler handler) {
      this.m_changeHandler = (EventHandler)Closure.remove(this.m_changeHandler, handler);
   }

   public Color getSelectedForeColor() {
      return this.m_selectedForeColor;
   }

   protected void onRowSelectorDraw(RowSelectorDrawEvent event) {
      if (this.m_rowSelectorDraw != null) {
         this.m_rowSelectorDraw.invoke(this, event);
      } else {
         this.m_rowSelectorDisplayer.eventHandler(event);
      }

   }

   public void setSelectedForeColor(Color color) {
      if (color == null) {
         this.setSelectedForeColor(Color.HIGHLIGHTTEXT);
      } else {
         if (!color.equals(this.m_selectedForeColor)) {
            this.m_selectedForeColor = color;
            this.notifyColumnsOfAmbientChange();
            this.invalidate();
         }

      }
   }

   public void onFieldChangeCompleteHandler(Object sender, RecordsetEvent event) {
      for(int col = this.m_columnCount - 1; col >= 0; --col) {
         Column currentCol = this.m_columns[col];

         for(int i = 0; i < event.cFields; ++i) {
            if (currentCol.getBoundWriteField() == event.fields[i]) {
               this.invalidateColumn(col);
               break;
            }
         }
      }

   }

   public void onRecordChangeCompleteHandler(Object sender, RecordsetEvent event) {
   }

   public Object getCurrentRow() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return this.m_dataProvider.getCurrentRow().getBookmark();
      }
   }

   public Column getCurrentColumn() {
      return this.m_currentColumn >= 0 && this.m_currentColumn < this.m_columnCount ? this.m_columns[this.m_currentColumn] : null;
   }

   protected Column getInternalColumn(int nIndex) {
      return this.m_columns[nIndex];
   }

   public void onMoveCompleteHandler(Object sender, RecordsetEvent event) {
      DataRow row = this.m_dataProvider.getCurrentRow();
      this.setCurrentColumnRow(this.m_currentColumn, row);
      if (Control.getMouseButtons() == 0) {
         this.showEditor();
      }

   }

   public void onRecordsetChangeCompleteHandler(Object sender, RecordsetEvent event) {
      this.invalidate();
   }

   protected int getLastVisibleColumn() {
      if (this.m_lastVisibleColumn == -1 && this.m_columnCount > 0) {
         for(int i = this.m_columnCount - 1; i >= 0; --i) {
            if (this.m_columns[i].isVisible()) {
               this.m_lastVisibleColumn = i;
               break;
            }
         }
      }

      return this.m_lastVisibleColumn;
   }

   public int getSelectEndColumn() {
      return -1;
   }

   private void doLayout() {
      this.m_clientRect = null;
      this.m_clientRectInside = null;
      Rectangle inside = this.getCachedClientInsideRect();
      this.m_vertScrollbar.setBounds(inside.x + inside.width, inside.y, this.m_vertScrollbar.getBounds().width, inside.height);
      this.m_horizScrollbar.setBounds(inside.x, inside.y + inside.height, inside.width, this.m_horizScrollbar.getBounds().height);
      if (this.m_dataProvider != null) {
         this.m_vertScrollbar.setEnabled(((Control)this).getEnabled());
         this.m_horizScrollbar.setEnabled(((Control)this).getEnabled());
      } else {
         this.m_vertScrollbar.setEnabled(false);
         this.m_horizScrollbar.setEnabled(false);
      }

      if (this.m_dataProvider != null) {
         this.m_dataProvider.setPageSize(this.calcPageSize());
         this.m_lastVisibleColumn = -1;
         this.m_firstVisibleColumn = -1;
         this.m_displayRowCount = -1;
         this.calcColumnBounds();
         this.calcRowBounds();
         if (this.m_columnCount > 0) {
            int nTotalWidth = this.getTotalWidth();
            int nNotVisible = nTotalWidth - this.m_clientRectInside.width;
            if (nNotVisible > 0) {
               this.m_horizScrollbar.setValues(0, nTotalWidth, 1, nTotalWidth / 5, this.m_horizScrollbar.getPosition());
            } else {
               this.m_horizScrollbar.setValues(0, 1, 1, 1, 0);
            }
         }

         this.updateVertScrollbar();
      }
   }

   protected void onBeforeColumnEdit(BeforeColumnEditEvent event) {
      if (this.m_beforeColumnEditHandler != null) {
         this.m_beforeColumnEditHandler.invoke(this, event);
      }

   }

   public void setCurrentRow(Object bookmark) {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         this.m_dataProvider.setCurrentRow(bookmark);
      }
   }

   public void setCurrentColumn(Column column) {
      if (column == null) {
         throw DataGridException.invalidCurrentColumn();
      } else {
         for(int i = 0; i < this.m_columnCount; ++i) {
            if (this.m_columns[i].equals(column)) {
               this.setCurrentColumnRow(i, this.m_currentRowRef);
               break;
            }
         }

      }
   }

   public int getScrollbars() {
      int ret = 0;
      if (this.m_showHorizScrollbar) {
         ret |= 2;
      }

      if (this.m_showVertScrollbar) {
         ret |= 1;
      }

      return ret;
   }

   public void setCurrentColumn(int displayIndex) {
      this.setCurrentColumn(this.getColumn(displayIndex));
   }

   public void addOnColumnEdit(ColumnEventHandler handler) {
      this.m_columnEditHandler = (ColumnEventHandler)Closure.combine(handler, this.m_columnEditHandler);
   }

   public void removeOnAfterColumnEdit(ColumnEventHandler handler) {
      this.m_afterColumnEditHandler = (ColumnEventHandler)Closure.remove(this.m_afterColumnEditHandler, handler);
   }

   public void removeOnHeaderClick(ColumnEventHandler handler) {
      this.m_headerClickHandler = (ColumnEventHandler)Closure.remove(this.m_headerClickHandler, handler);
   }

   public void setScrollbars(int scroll) {
      if (scroll != this.getScrollbars()) {
         if ((scroll & 2) == 2) {
            this.m_showHorizScrollbar = true;
         } else {
            this.m_showHorizScrollbar = false;
         }

         if ((scroll & 1) == 1) {
            this.m_showVertScrollbar = true;
         } else {
            this.m_showVertScrollbar = false;
         }

         this.doLayout();
         this.invalidate();
      }

   }

   public void setSelectEndColumn(int displayIndex) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         ;
      }
   }

   private synchronized void processDrag(int mouseX, int mouseY) {
      if (this.m_trackingDrag) {
         this.m_selection.updateSelections(this);
      }
   }

   protected void onAfterUpdate(Event event) {
      if (this.m_afterUpdateHandler != null) {
         this.m_afterUpdateHandler.invoke(this, event);
      }

   }

   protected void onBeforeDelete(CancelEvent event) {
      if (this.m_beforeDeleteHandler != null) {
         this.m_beforeDeleteHandler.invoke(this, event);
      }

   }

   public void setAllowDelete(boolean allowDelete) {
      this.m_allowDelete = allowDelete;
   }

   protected void onMouseUp(MouseEvent me) {
      super.onMouseUp(me);
      if (this.m_dataProvider != null && ((Control)this).getEnabled()) {
         if (Math.abs(this.m_lastX - me.x) < 2 && Math.abs(this.m_lastY - me.y) < 2) {
            DataGridLocation loc = new DataGridLocation(this, me.x, me.y);
            boolean bOverCell = (loc.m_type & 4) == 4;
            boolean bOverColumnHeader = (loc.m_type & 1) == 1;
            if (bOverCell) {
               this.showEditor();
            } else if (bOverColumnHeader) {
               this.onHeaderClick(new ColumnEvent(loc.m_column));
            }
         }

         if (this.m_trackingResize) {
            this.processResize(-2, me.x, me.y);
            if (this.m_columnResizing != -1) {
               int nWidth = this.m_columns[this.m_columnResizing].m_width + me.x - this.m_trackXStart;
               if (nWidth < 15) {
                  nWidth = 15;
               }

               ColumnResizeEvent resize = null;
               resize = new ColumnResizeEvent(this.m_columnResizing, nWidth, false);
               this.onColumnResize(resize);
               if (!resize.cancel) {
                  this.m_columns[this.m_columnResizing].m_width = nWidth;
                  this.calcColumnBounds();
                  this.invalidate();
               }
            } else {
               int nHeight = this.m_rowHeight + me.y - this.m_trackYStart;
               if (nHeight < 15) {
                  nHeight = 15;
               }

               this.setInternalRowHeight(nHeight);
            }
         } else if (this.m_trackingDrag) {
            this.m_trackingDrag = false;
            this.m_dragRowLast = null;
            this.m_dragColumnLast = -1;
            this.m_dragRowStart = null;
            this.m_dragColumnStart = -1;
         }

      }
   }

   public Object[] getSelectedRows() {
      DataRow[] rows = this.m_selection.getRows();
      if (rows == null) {
         return null;
      } else {
         Object[] rowIndexes = new Object[rows.length];

         for(int i = 0; i < rowIndexes.length; ++i) {
            rowIndexes[i] = rows[i].getBookmark();
         }

         return rowIndexes;
      }
   }

   public void addOnAfterColumnUpdate(ColumnEventHandler handler) {
      this.m_afterColumnUpdateHandler = (ColumnEventHandler)Closure.combine(handler, this.m_afterColumnUpdateHandler);
   }

   public void removeOnAfterDelete(EventHandler handler) {
      this.m_afterDeleteHandler = (EventHandler)Closure.remove(this.m_afterDeleteHandler, handler);
   }

   public void removeOnBeforeColumnUpdate(BeforeColumnUpdateEventHandler handler) {
      this.m_beforeColumnUpdateHandler = (BeforeColumnUpdateEventHandler)Closure.remove(this.m_beforeColumnUpdateHandler, handler);
   }

   public void removeOnValidate(CancelEventHandler handler) {
      this.m_validateHandler = (CancelEventHandler)Closure.remove(this.m_validateHandler, handler);
   }

   public void setSelectedRows(Object[] bookmarks) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         this.m_selection.clearSelection();
         if (bookmarks != null) {
            for(int i = 0; i < bookmarks.length; ++i) {
               this.m_selection.selectRow(this.m_dataProvider.getDisplayRow(bookmarks[i]));
            }
         }

         this.m_selection.updateSelections(this);
      }
   }

   private boolean processMoveKey(int virtKeyCode) {
      boolean usedKey = true;
      switch (virtKeyCode) {
         case 9:
            if (this.m_tabAction == 2) {
               this.processMoveKey(40);
            } else if (this.m_tabAction == 1) {
               this.processMoveKey(39);
            }
            break;
         case 13:
            if (this.m_enterAction == 2) {
               this.processMoveKey(40);
            } else if (this.m_enterAction == 1) {
               this.processMoveKey(39);
            }
            break;
         case 33:
            this.m_dataProvider.move(this.m_currentRowRef, -1 * this.getVisibleRows());
            break;
         case 34:
            this.m_dataProvider.move(this.m_currentRowRef, this.getVisibleRows());
            break;
         case 35:
            this.beginColumnRowChange();
            this.m_currentColumn = this.getColumnCount() - 1;
            this.m_dataProvider.moveLast();
            this.endColumnRowChange();
            break;
         case 36:
            this.beginColumnRowChange();
            this.m_currentColumn = 0;
            this.m_dataProvider.moveFirst();
            this.endColumnRowChange();
            break;
         case 37:
            if (this.m_currentColumn > 0) {
               this.setCurrentColumnRow(this.m_currentColumn - 1, this.m_currentRowRef);
            } else if (this.m_wrapCellPointer) {
               this.beginColumnRowChange();
               this.m_currentColumn = this.getColumnCount() - 1;
               this.m_dataProvider.movePrevious();
               this.endColumnRowChange();
            }
            break;
         case 38:
            this.m_dataProvider.movePrevious();
            break;
         case 39:
            if (this.m_currentColumn < this.getColumnCount() - 1) {
               this.setCurrentColumnRow(this.m_currentColumn + 1, this.m_currentRowRef);
            } else if (this.m_wrapCellPointer) {
               this.beginColumnRowChange();
               this.m_currentColumn = 0;
               this.m_dataProvider.moveNext();
               this.endColumnRowChange();
            }
            break;
         case 40:
            this.m_dataProvider.moveNext();
            break;
         default:
            usedKey = false;
      }

      return usedKey;
   }

   private void calcColumnBounds() {
      Rectangle inside = this.getCachedClientInsideRect();
      int lineWidth = this.m_gridLinesDisplayer.getLineWidth();
      int xPosition = inside.x + this.getRowSelectorWidth() - this.m_horizOffset;

      for(int i = 0; i < this.m_columnCount; ++i) {
         if (this.m_columns[i].isVisible()) {
            this.m_columns[i].m_x = xPosition;
            xPosition += this.m_columns[i].m_width + lineWidth;
         } else {
            this.m_columns[i].m_x = -1;
         }
      }

   }

   protected int getHorizOffset() {
      return this.m_horizOffset;
   }

   public void setHorizOffset(int newOffset) {
      if (newOffset < 0) {
         newOffset = 0;
      }

      int change = this.m_horizOffset - newOffset;
      this.m_horizScrollbar.setPosition(newOffset);
      Rectangle scroll = new Rectangle(this.getCachedClientInsideRect());
      scroll.x += this.getRowSelectorWidth();
      scroll.width -= this.getRowSelectorWidth();
      Windows.ScrollWindow(((Control)this).getHandle(), change, 0, scroll.toRECT(), scroll.toRECT());
      this.m_horizOffset = newOffset;
      this.calcColumnBounds();
      if (this.m_editorCurrent != null) {
         Control editorControl = null;
         Rectangle inside = this.getCachedClientInsideRect();

         try {
            editorControl = (Control)this.m_editorCurrent;
            Rectangle bounds = editorControl.getBounds();
            bounds.x = this.m_columns[this.m_currentColumn].m_x;
            bounds.width = this.m_columns[this.m_currentColumn].m_width;
            if (bounds.x < inside.x + this.getRowSelectorWidth()) {
               bounds.width += bounds.x - (inside.x + this.getRowSelectorWidth());
               bounds.x = inside.x + this.getRowSelectorWidth();
            }

            if (bounds.x + bounds.width > inside.x + inside.width) {
               bounds.width = inside.x + inside.width - bounds.x;
               if (bounds.width < 0) {
                  bounds.width = 0;
               }
            }

            Rectangle currentBounds = editorControl.getBounds();
            if (bounds.x != currentBounds.x || bounds.y != currentBounds.y || bounds.width != currentBounds.width || bounds.height != currentBounds.height) {
               editorControl.setBounds(bounds);
            }
         } catch (Exception var8) {
         }
      }

   }

   protected void onError(ErrorEvent event) {
      if (this.m_errorHandler != null) {
         this.m_errorHandler.invoke(this, event);
      }

   }

   public int getBorderStyle() {
      return this.m_borderStyle;
   }

   public int getGridLineStyle() {
      return this.m_gridLineStyle;
   }

   public void setBorderStyle(int borderStyle) {
      if (this.m_borderStyle != borderStyle) {
         if (!this.isValidBorderStyle(borderStyle)) {
            throw DataGridException.invalidBorderStyle();
         }

         this.m_borderStyle = borderStyle;
         this.setupBorder();
         this.doLayout();
         this.invalidate();
      }

   }

   public void setGridLineStyle(int gridLineStyle) {
      if (this.m_gridLineStyle != gridLineStyle) {
         this.m_gridLineStyle = gridLineStyle;
         if (!this.isValidGridStyle(gridLineStyle)) {
            throw DataGridException.invalidGridLineStyle();
         }

         GridLineDisplayer disp = this.m_gridLinesDisplayer;
         switch (this.m_gridLineStyle) {
            case 1:
               disp.setLineStyle(1);
               break;
            case 2:
               disp.setLineStyle(18);
               break;
            case 3:
               disp.setLineStyle(34);
               break;
            default:
               disp.setLineStyle(4);
         }

         this.doLayout();
         this.invalidate();
      }

   }

   protected Rectangle getCachedClientRect() {
      if (this.m_clientRect == null) {
         int borderWidth = this.m_borderDisplayer.getBorderWidth();
         int borderHeight = this.m_borderDisplayer.getBorderHeight();
         int captionHeight = this.getCaptionHeight();
         Rectangle client = ((Control)this).getClientRect();
         Rectangle inside = new Rectangle();
         inside.x = client.x + borderWidth;
         inside.y = client.y + borderHeight + captionHeight;
         inside.width = client.width - 2 * borderWidth - this.getScrollbarWidth();
         inside.height = client.height - 2 * borderHeight - this.getScrollbarHeight() - captionHeight;
         Rectangle resize = new Rectangle(inside.x + inside.width, inside.y + inside.height, this.getScrollbarWidth(), this.getScrollbarHeight());
         this.m_resizeBoxRect = resize;
         this.m_clientRectInside = inside;
         this.m_clientRect = client;
      }

      Debug.assert(this.m_clientRect != null, "m_clientRect can't be null");
      return this.m_clientRect;
   }

   private void calcHeaderHeight() {
      Graphics g = ((Control)this).createGraphics();
      g.setFont(this.getHeaderFont());
      TEXTMETRIC tm = new TEXTMETRIC();
      Windows.GetTextMetrics(g.getHandle(), tm);
      this.m_columnHeaderHeight = this.m_headerLineCount * tm.tmHeight + 4;
      g.dispose();
   }

   private int getScrollbarHeight() {
      return this.m_showHorizScrollbar ? this.m_horizScrollbar.getBounds().height : 0;
   }

   protected void setInternalRowHeight(int height) {
      if (height != this.m_rowHeight) {
         if (height < 15) {
            throw DataGridException.invalidRowHeight();
         }

         CancelEvent cancel = new CancelEvent(false);
         this.onRowResize(cancel);
         if (!cancel.cancel) {
            this.m_rowHeight = height;
            if (this.m_rowSelectorDisplayer != null) {
               this.m_rowSelectorDisplayer.setSize(this.m_rowSelectorWidth, this.m_rowHeight);
            }

            this.doLayout();
            this.invalidate();
         }
      }

   }

   private Rectangle getCaptionBounds() {
      Rectangle inside = this.getCachedClientInsideRect();
      return new Rectangle(inside.x, inside.y - this.getCaptionHeight(), inside.width + this.getScrollbarWidth(), this.getCaptionHeight());
   }

   protected Rectangle getCellBounds(int columnDisplayIndex, DataRow row) {
      int nLineWidth = this.m_gridLinesDisplayer.getLineWidth();
      int nLineHeight = this.m_gridLinesDisplayer.getLineHeight();
      int nRowHeightWithLine = this.m_rowHeight + nLineHeight;
      if (columnDisplayIndex >= 0 && columnDisplayIndex < this.m_columnCount && row != null) {
         DataRow curRow = this.m_dataProvider.getDisplayRow(row.getBookmark());
         if (curRow != null) {
            Column curColumn = this.m_columns[columnDisplayIndex];
            if (curRow != null && curColumn.isVisible() && curRow.getDisplayIndex() >= 0) {
               int y = this.getCachedClientInsideRect().y + this.getColumnHeaderHeight() + nRowHeightWithLine * curRow.getDisplayIndex();
               Rectangle rect = new Rectangle(curColumn.m_x, y, curColumn.m_width, this.m_rowHeight);
               return rect;
            }
         }
      }

      return null;
   }

   protected Rectangle getCellBounds(GridCell cell) {
      return this.getCellBounds(cell.m_column, cell.m_row);
   }

   public int getHeaderLineCount() {
      return this.m_headerLineCount;
   }

   protected void onNoRowsetPaint(PaintEvent e) {
      Rectangle inside = this.getCachedClientInsideRect();
      int nLineWidth = this.m_gridLinesDisplayer.getLineWidth();
      int nLineHeight = this.m_gridLinesDisplayer.getLineHeight();
      int var10000 = this.m_rowHeight + nLineHeight;
      int nColumnHeaderHeight = this.getColumnHeaderHeight();
      int nCaptionHeight = this.getCaptionHeight();
      this.m_clipRect = e.clipRect;
      Rectangle clip = e.clipRect;
      this.m_borderDisplayer.paintIn(e.graphics, this.getCachedClientRect(), e.clipRect);
      if (this.m_caption != null) {
         this.m_captionDisplayer.paintIn(e.graphics, this.getCaptionBounds(), e.clipRect, (String)null);
      }

      e.graphics.setPen((Pen)null);
      e.graphics.setBrush(this.m_unusedAreaBrush);
      e.graphics.drawRect(inside);
   }

   public boolean isAllowAddNew() {
      return this.m_showPhantomRow;
   }

   protected void onPaint(PaintEvent e) {
      this.m_pendingInvalidate = false;
      if (this.m_dataProvider == null) {
         this.onNoRowsetPaint(e);
      } else {
         Rectangle inside = this.getCachedClientInsideRect();
         Rectangle clip = e.clipRect;
         int lineWidth = this.m_gridLinesDisplayer.getLineWidth();
         int lineHeight = this.m_gridLinesDisplayer.getLineHeight();
         int rowHeightWithLine = this.m_rowHeight + lineHeight;
         int columnHeaderHeight = this.getColumnHeaderHeight();
         int captionHeight = this.getCaptionHeight();
         int lastVisibleColumn = this.getLastVisibleColumn();
         Column lastVisible = this.m_columns[lastVisibleColumn];
         this.m_clipRect = clip;
         boolean columnHeadersInvalid = false;
         boolean rowHeadersInvalid = false;
         int firstInvalidRow = 0;
         int lastInvalidRow = this.getBottomRow();
         int firstInvalidColumn = 0;
         int lastInvalidColumn = lastVisibleColumn;
         int dc = e.graphics.getHandle();
         int clipLeft = clip.x;
         int clipTop = clip.y;
         int clipWidth = clip.width;
         boolean clipDataReliable = true;
         if (!Windows.PtVisible(dc, clip.x, clip.y)) {
            clipDataReliable = false;
         }

         if (clipTop < columnHeaderHeight + inside.y) {
            columnHeadersInvalid = true;
         }

         if (clipLeft < inside.x + this.m_rowSelectorWidth && this.m_showRowSelectors) {
            rowHeadersInvalid = true;
         }

         if (this.m_columnCount > 0) {
            for(int i = lastVisibleColumn; i >= 0; --i) {
               Column col = this.m_columns[i];
               if (col.isVisible()) {
                  if (col.m_x < clipLeft) {
                     firstInvalidColumn = lastVisibleColumn;
                  }
                  break;
               }
            }
         }

         if (firstInvalidColumn == 0) {
            for(int i = lastVisibleColumn; i >= 0; --i) {
               Column cur = this.m_columns[i];
               if (cur.isVisible()) {
                  if (clipLeft >= cur.m_x && clipLeft < cur.m_x + cur.m_width) {
                     firstInvalidColumn = i;
                  }

                  if (clipLeft + clipWidth > cur.m_x && clipLeft + clipWidth <= cur.m_x + cur.m_width) {
                     lastInvalidColumn = i;
                  }
               }
            }
         }

         firstInvalidRow = (clip.y - columnHeaderHeight - inside.y) / rowHeightWithLine;
         if (firstInvalidRow < 0) {
            firstInvalidRow = 0;
         }

         lastInvalidRow = (clip.y + clip.height - columnHeaderHeight - inside.y) / rowHeightWithLine;
         int bottomRow = this.getBottomRow();
         if (lastInvalidRow > bottomRow) {
            lastInvalidRow = bottomRow;
         }

         this.m_borderDisplayer.paintIn(e.graphics, this.getCachedClientRect(), e.clipRect);
         if (this.m_caption != null) {
            this.m_captionDisplayer.paintIn(e.graphics, this.getCaptionBounds(), e.clipRect, (String)null);
         }

         e.graphics.intersectClipRect(inside);
         this.m_gridLinesDisplayer.paintIn(e.graphics, inside, e.clipRect, this);
         if (columnHeadersInvalid && this.m_showColumnHeaders) {
            if (this.m_showRowSelectors) {
               Rectangle upperLeftBox = new Rectangle(inside.x, inside.y, this.m_rowSelectorWidth, columnHeaderHeight);
               if (upperLeftBox.intersectsWith(e.clipRect)) {
                  RowSelectorDrawData data = new RowSelectorDrawData();
                  this.onRowSelectorDraw(new RowSelectorDrawEvent(e.graphics, upperLeftBox, e.clipRect, data));
                  e.graphics.excludeClipRect(inside.x, inside.y, inside.x + this.m_rowSelectorWidth, inside.y + columnHeaderHeight);
               }
            }

            Rectangle headerArea = new Rectangle(inside.x, inside.y, lastVisible.m_x + lastVisible.m_width + lineWidth - inside.x, columnHeaderHeight);
            if (headerArea.intersectsWith(e.clipRect)) {
               for(int i = 0; i < this.m_columnCount; ++i) {
                  Column currentColumn = this.m_columns[i];
                  ColumnHeaderDrawEventHandler draw = null;
                  Rectangle headerBounds = null;
                  draw = currentColumn.m_headerDraw;
                  headerBounds = new Rectangle(currentColumn.m_x, inside.y, currentColumn.m_width, columnHeaderHeight);
                  if (draw != null) {
                     draw.invoke(this, new ColumnHeaderDrawEvent(e.graphics, headerBounds, e.clipRect, (ColumnHeaderDrawData)null));
                  } else {
                     ColumnHeaderDisplayer disp = null;
                     disp = currentColumn.m_headerDisplayer;
                     disp.paintIn(e.graphics, headerBounds, e.clipRect, (String)null);
                  }
               }

               if (this.m_columnCount > 0) {
                  e.graphics.excludeClipRect(inside.x, inside.y, lastVisible.m_x + lastVisible.m_width + lineWidth, inside.y + columnHeaderHeight);
               }
            }
         }

         RECT testRect = new RECT();
         Rectangle rowArea = new Rectangle();
         rowArea.x = inside.x;
         rowArea.width = inside.width;
         rowArea.height = this.m_rowHeight;
         rowArea.y = inside.y + columnHeaderHeight + (firstInvalidRow - 1) * rowHeightWithLine;
         Rectangle cellBounds = new Rectangle();
         cellBounds.height = this.m_rowHeight;

         for(int currentRow = firstInvalidRow; currentRow <= lastInvalidRow; ++currentRow) {
            DataRow currentRowRef = this.m_dataProvider.getDisplayRow(currentRow);
            rowArea.y += rowHeightWithLine;
            cellBounds.y = rowArea.y;
            boolean drawThisRow = true;
            if (!clipDataReliable) {
               testRect.top = rowArea.y;
               testRect.bottom = rowArea.y + rowArea.height;
               testRect.left = rowArea.x;
               testRect.right = rowArea.x + rowArea.width;
               drawThisRow = Windows.RectVisible(dc, testRect);
            }

            if (drawThisRow) {
               if (this.m_showRowSelectors) {
                  Rectangle rowSelectorBounds = new Rectangle(inside.x, rowArea.y, this.m_rowSelectorWidth, this.m_rowHeight);
                  if (this.m_rowSelectorDraw == null) {
                     if (DataProvider.rowsEqual(currentRowRef, this.m_editRowRef)) {
                        this.m_rowSelectorDisplayer.setEditRow(true);
                     } else if (DataProvider.rowsEqual(currentRowRef, this.m_currentRowRef)) {
                        this.m_rowSelectorDisplayer.setCurrentRow(true);
                     } else if (currentRowRef == null) {
                        this.m_rowSelectorDisplayer.setNewRow(true);
                     }

                     this.m_rowSelectorDisplayer.paintIn(e.graphics, rowSelectorBounds, e.clipRect);
                     if (DataProvider.rowsEqual(currentRowRef, this.m_editRowRef)) {
                        this.m_rowSelectorDisplayer.setEditRow(false);
                     } else if (DataProvider.rowsEqual(currentRowRef, this.m_currentRowRef)) {
                        this.m_rowSelectorDisplayer.setCurrentRow(false);
                     } else if (currentRowRef == null) {
                        this.m_rowSelectorDisplayer.setNewRow(false);
                     }
                  } else {
                     RowSelectorDrawData data = new RowSelectorDrawData();
                     this.onRowSelectorDraw(new RowSelectorDrawEvent(e.graphics, rowSelectorBounds, e.clipRect, data));
                  }

                  e.graphics.excludeClipRect(inside.x, rowArea.y, inside.x + this.m_rowSelectorWidth, rowArea.y + rowHeightWithLine);
               }

               for(int currentColumn = firstInvalidColumn; currentColumn <= lastInvalidColumn; ++currentColumn) {
                  Column col = this.m_columns[currentColumn];
                  cellBounds.x = col.m_x;
                  cellBounds.width = col.m_width;
                  boolean drawThisCell = true;
                  if (!clipDataReliable) {
                     testRect.left = cellBounds.x;
                     testRect.right = cellBounds.x + cellBounds.width;
                     drawThisCell = Windows.RectVisible(dc, testRect);
                  }

                  if (drawThisCell) {
                     CellDisplayer disp = col.m_cellDisplayer;
                     CellDrawEventHandler draw = col.m_cellDraw;
                     boolean mouseOver = false;
                     boolean hasFocus = false;
                     boolean selected = false;
                     String formattedData = null;
                     if (currentRowRef == null) {
                        formattedData = "";
                     } else {
                        Field field = col.getBoundReadField();
                        if (field != null) {
                           formattedData = this.m_dataProvider.getFormattedData(currentRowRef, field);
                        } else {
                           formattedData = "";
                        }
                     }

                     if (DataProvider.rowsEqual(currentRowRef, this.m_hotCell.m_row) && currentColumn == this.m_hotCell.m_column) {
                        mouseOver = true;
                     }

                     if (DataProvider.rowsEqual(currentRowRef, this.m_marqueeCell.m_row) && currentColumn == this.m_marqueeCell.m_column) {
                        hasFocus = true;
                     }

                     if (this.m_selection.isCellSelected(currentColumn, currentRowRef)) {
                        selected = true;
                     }

                     if (draw == null) {
                        if (disp.isMouseOver() != mouseOver) {
                           disp.setMouseOver(mouseOver);
                        }

                        if (disp.isHasFocus() != hasFocus) {
                           disp.setHasFocus(hasFocus);
                        }

                        if (disp.isSelected() != selected) {
                           disp.setSelected(selected);
                        }

                        disp.paintIn(e.graphics, cellBounds, e.clipRect, formattedData);
                     } else {
                        CellDrawData data = new CellDrawData();
                        data.m_mouseOver = mouseOver;
                        data.m_focus = hasFocus;
                        data.m_selected = selected;
                        data.m_wrap = col.m_wrap;
                        data.m_foreColor = col.getForeColor();
                        data.m_backColor = col.getBackColor();
                        data.m_selectedForeColor = col.getSelectedForeColor();
                        data.m_selectedBackColor = col.getSelectedBackColor();
                        data.m_alignment = col.getAlignment();
                        draw.invoke(this, new CellDrawEvent(e.graphics, cellBounds, e.clipRect, data));
                     }
                  }
               }
            }
         }

         int rightEndOfContent = 0;
         if (this.m_columnCount > 0) {
            rightEndOfContent = this.m_columns[lastVisibleColumn].m_x + this.m_columns[lastVisibleColumn].m_width + lineWidth;
         } else {
            rightEndOfContent = this.getRowSelectorWidth();
         }

         if (rightEndOfContent < inside.x + inside.width) {
            e.graphics.setPen((Pen)null);
            e.graphics.setBrush(this.m_unusedAreaBrush);
            e.graphics.drawRect(rightEndOfContent, inside.y, inside.width - (rightEndOfContent - inside.x), inside.height);
         }

         int lastRow = this.getBottomRow();
         if (lastRow >= 0) {
            int bottomEndOfContent = 0;
            bottomEndOfContent = columnHeaderHeight + inside.y + rowHeightWithLine * (lastRow + 1);
            if (bottomEndOfContent < inside.y + inside.height) {
               e.graphics.setPen((Pen)null);
               e.graphics.setBrush(this.m_unusedAreaBrush);
               e.graphics.drawRect(inside.x, bottomEndOfContent, inside.width, inside.height - (bottomEndOfContent - inside.y));
            }
         }

      }
   }

   public void setHeaderLineCount(int lines) {
      if (lines != this.m_headerLineCount) {
         if (lines < 1) {
            throw DataGridException.invalidHeaderLineCount();
         }

         this.m_headerLineCount = lines;

         for(int i = this.m_columnCount - 1; i >= 0; --i) {
            this.m_columns[i].m_headerDisplayer.setWrap(lines > 1);
         }

         this.m_columnHeaderHeight = -1;
         this.doLayout();
         this.invalidate();
      }

   }

   public Object rowBookmark(int displayRow) {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else if (displayRow >= 0 && displayRow <= this.getBottomRow()) {
         return this.m_dataProvider.getDisplayRow(displayRow).getBookmark();
      } else {
         throw DataGridException.invalidRowReference();
      }
   }

   public int getEnterAction() {
      return this.m_enterAction;
   }

   private boolean isValidTabAction(int action) {
      return action >= 0 && action <= 2;
   }

   public void setEnterAction(int action) {
      if (!this.isValidEnterAction(action)) {
         throw new IllegalArgumentException("Invalid enter action");
      } else {
         this.m_enterAction = action;
      }
   }

   private void setMarqueePosition(GridCell cell) {
      if (cell != null) {
         if (!DataProvider.rowsEqual(this.m_marqueeCell.m_row, cell.m_row) || this.m_marqueeCell.m_column != cell.m_column) {
            if (this.m_marqueeCell.m_row != null || this.m_marqueeCell.m_column != -1) {
               Rectangle bounds = this.getCellBounds(this.m_marqueeCell);
               if (bounds != null) {
                  ((Control)this).invalidateRect(bounds);
               }

               this.m_marqueeCell.m_row = null;
               this.m_marqueeCell.m_column = -1;
               ((Control)this).update();
            }

            this.m_marqueeCell.m_row = cell.m_row;
            this.m_marqueeCell.m_column = cell.m_column;
            Rectangle bounds = this.getCellBounds(this.m_marqueeCell);
            if (bounds != null) {
               ((Control)this).invalidateRect(bounds);
            }

            ((Control)this).update();
            this.ensureCellVisible(this.m_marqueeCell);
         }
      } else if (this.m_marqueeCell.m_row != null || this.m_marqueeCell.m_column != -1) {
         Rectangle bounds = this.getCellBounds(this.m_marqueeCell);
         if (bounds != null) {
            ((Control)this).invalidateRect(bounds);
         }

         this.m_marqueeCell.m_row = null;
         this.m_marqueeCell.m_column = -1;
         ((Control)this).update();
      }

   }

   public Column[] getSelectedColumns() {
      int[] columnIndexes = this.m_selection.getColumns();
      Column[] columns = null;
      if (columnIndexes != null) {
         columns = new Column[columnIndexes.length];

         for(int i = 0; i < columns.length; ++i) {
            columns[i] = this.getInternalColumn(columnIndexes[i]);
         }
      }

      return columns;
   }

   protected int calcPageSize() {
      int height = this.m_gridLinesDisplayer.getLineHeight() + this.m_rowHeight;
      return (this.getCachedClientInsideRect().height - this.getColumnHeaderHeight() + height - 1) / height;
   }

   protected void onRowResize(CancelEvent event) {
      if (this.m_rowResizeHandler != null) {
         this.m_rowResizeHandler.invoke(this, event);
      }

   }

   public void setSelectedColumns(Column[] columns) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         this.m_selection.clearSelection();
         if (columns != null) {
            for(int i = 0; i < columns.length; ++i) {
               this.m_selection.selectColumn(columns[i].getIndex());
            }
         }

         this.m_selection.updateSelections(this);
      }
   }

   protected void clearHotTrack() {
      Debug.assert(this.m_hotCell != null, "clearHotTrack with no m_hotCell");
      if (this.m_hotCell.m_row != null || this.m_hotCell.m_column != -1) {
         Rectangle rect = this.getCellBounds(this.m_hotCell);
         if (rect != null) {
            ((Control)this).invalidateRect(rect);
         }

         this.m_hotCell.m_row = null;
         this.m_hotCell.m_column = -1;
         ((Control)this).update();
      }

      Rectangle inside = this.getCachedClientInsideRect();

      for(int i = 0; i < this.m_columnCount; ++i) {
         if (this.m_columns[i].m_headerDisplayer.isMouseOver()) {
            this.m_columns[i].m_headerDisplayer.setMouseOver(false);
            ((Control)this).invalidateRect(new Rectangle(this.m_columns[i].m_x, inside.y, this.m_columns[i].m_width, this.getColumnHeaderHeight()));
         }
      }

   }

   protected void onColumnEdit(ColumnEvent event) {
      if (this.m_columnEditHandler != null) {
         this.m_columnEditHandler.invoke(this, event);
      }

   }

   public void addOnBeforeColumnEdit(BeforeColumnEditEventHandler handler) {
      this.m_beforeColumnEditHandler = (BeforeColumnEditEventHandler)Closure.combine(handler, this.m_beforeColumnEditHandler);
   }

   public String getCurrentCellValue() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         Field boundRead = this.m_columns[this.m_currentColumn].getBoundReadField();
         return this.m_dataProvider.getFormattedData(this.m_currentRowRef, boundRead);
      }
   }

   public void setCurrentCellValue(String val) {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         Field boundWrite = this.m_columns[this.m_currentColumn].getBoundWriteField();
         this.m_dataProvider.setFormattedData(boundWrite, val);
      }
   }

   private void invalidateRowSelector(DataRow row) {
      if (row != null) {
         Rectangle bounds = this.getCellBounds(new GridCell(this, this.getFirstVisibleColumn(), row));
         if (bounds != null) {
            Rectangle inside = this.getCachedClientInsideRect();
            bounds.x = inside.x;
            bounds.width = this.m_rowSelectorWidth;
            ((Control)this).invalidateRect(bounds);
            ((Control)this).update();
         }

      }
   }

   protected void onAfterInsert(Event event) {
      if (this.m_afterInsertHandler != null) {
         this.m_afterInsertHandler.invoke(this, event);
      }

   }

   protected void onScroll(CancelEvent event) {
      if (this.m_scrollHandler != null) {
         this.m_scrollHandler.invoke(this, event);
      }

   }

   public void setAsyncPostMessage(int message) {
      this.m_dataProviderAsyncMessage = message;
   }

   protected void columnPropertyChange(int property, Column column) {
      Debug.assert(column != null, "columnPropertyChange with no column");
      switch (property) {
         case 1:
         case 3:
         case 4:
         case 6:
         case 10:
         case 12:
         case 13:
         case 16:
         case 17:
         case 18:
         case 19:
            this.invalidateColumn(column.getIndex());
         case 2:
         case 8:
         case 9:
         case 14:
         case 15:
         default:
            break;
         case 5:
         case 20:
            this.doLayout();
            this.invalidate();
            break;
         case 7:
            for(int currentIndex = 0; currentIndex < this.m_columnCount; ++currentIndex) {
               if (column == this.m_columns[currentIndex]) {
                  int correctIndex = column.getIndex();
                  if (correctIndex >= this.m_columnCount) {
                     correctIndex = this.m_columnCount - 1;
                  } else if (correctIndex < 0) {
                     correctIndex = 0;
                  }

                  column.internalSetIndex(correctIndex);
                  if (currentIndex != correctIndex) {
                     Column[] ordered = new Column[this.m_columnCount];
                     int src = 0;
                     boolean repositioned = false;

                     for(int i = 0; i < this.m_columnCount; ++i) {
                        if (i == currentIndex && !repositioned) {
                           ++src;
                        }

                        if (src == currentIndex && repositioned) {
                           ++src;
                        }

                        if (i == correctIndex) {
                           repositioned = true;
                           ordered[i] = column;
                           ++i;
                        }

                        if (i < this.m_columnCount) {
                           ordered[i] = this.m_columns[src];
                           ordered[i].internalSetIndex(i);
                        }

                        ++src;
                     }

                     this.m_columns = ordered;
                     this.doLayout();
                     this.invalidate();
                  }

                  return;
               }
            }
            break;
         case 11:
            if (this.m_editRowRef != null && DataProvider.rowsEqual(this.m_editRowRef, this.m_currentRowRef) && this.m_currentColumn == column.getIndex()) {
               this.removeEditor(true);
            }
      }

   }

   protected void onColumnRowChange(ColumnRowChangeEvent event) {
      if (this.m_columnRowChangeHandler != null) {
         this.m_columnRowChangeHandler.invoke(this, event);
      }

   }

   protected void onSelChange(CancelEvent event) {
      if (this.m_selChangeHandler != null) {
         this.m_selChangeHandler.invoke(this, event);
      }

   }

   public void addOnRowSelectorDraw(RowSelectorDrawEventHandler draw) {
      if (draw != this.m_rowSelectorDraw) {
         this.m_rowSelectorDraw = (RowSelectorDrawEventHandler)Closure.combine(draw, this.m_rowSelectorDraw);
         this.invalidate();
      }

   }

   protected int editorWndProc(int hwnd, int msg, int wparam, int lparam) {
      boolean callDefault = true;
      int ret = 0;
      switch (msg) {
         case 8:
            this.removeEditor();
            break;
         case 256:
            if (!this.m_editorCurrent.isKeyUsedByEditor(wparam)) {
               this.processMoveKey(wparam);
            }
      }

      if (callDefault && this.m_editorDefaultWndProc != 0) {
         ret = Windows.CallWindowProc(this.m_editorDefaultWndProc, hwnd, msg, wparam, lparam);
      }

      return ret;
   }

   protected Rectangle getClipRect() {
      return this.m_clipRect;
   }

   public Object getFirstRow() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         DataRow top = this.m_dataProvider.getDisplayRow(0);
         return top != null ? top.getBookmark() : null;
      }
   }

   private void setCurrentColumnRow(int column, DataRow row) {
      if (!this.m_internalRowReposition) {
         this.beginColumnRowChange();
         this.removeEditor();
         this.m_currentColumn = column;
         if (!DataProvider.rowsEqual(this.m_currentRowRef, row)) {
            this.m_currentRowRef = row;
         } else {
            this.showEditor();
         }

         this.endColumnRowChange();
      } else {
         this.m_currentColumn = column;
         this.m_currentRowRef = row;
      }

   }

   public void setFirstRow(Object row) {
      if (row == null) {
         throw DataGridException.invalidRowReference();
      } else if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         this.m_dataProvider.scroll(0, row);
      }
   }

   protected void propertyChanged(int nProp) {
      switch (nProp) {
         case 2:
            this.doLayout();
            this.invalidate();
            break;
         case 6:
            this.notifyColumnsOfAmbientChange();
            if (this.m_headerFont == null) {
               this.m_columnHeaderHeight = -1;
            }

            this.invalidate();
            break;
         case 8:
         case 10:
            this.notifyColumnsOfAmbientChange();
            this.invalidate();
      }

      super.propertyChanged(nProp);
   }

   public DataGrid() {
      this.m_selectedForeColor = Color.HIGHLIGHTTEXT;
      this.m_selectedBackColor = Color.HIGHLIGHT;
      this.m_headerLineCount = 1;
      this.m_allowDelete = true;
      this.m_allowRowSizing = true;
      this.m_allowUpdate = true;
      this.m_showRowSelectors = true;
      this.m_showVertScrollbar = true;
      this.m_showHorizScrollbar = true;
      this.m_holdColumns = false;
      this.m_columns = null;
      this.m_columnCount = 0;
      this.m_horizScrollbar = new HScrollBar();
      this.m_vertScrollbar = new VScrollBar();
      this.m_captionDisplayer = new ColumnHeaderDisplayer();
      this.m_rowSelectorDraw = null;
      this.m_rowSelectorDisplayer = new RowSelectorDisplayer();
      this.m_gridLinesDisplayer = new GridLineDisplayer();
      this.m_borderDisplayer = new BorderDisplayer();
      this.m_clientRect = null;
      this.m_clientRectInside = null;
      this.m_resizeBoxRect = null;
      this.m_controlBrush = new Brush(Color.CONTROL);
      this.m_unusedAreaBrush = new Brush(Color.CONTROLDARK);
      this.m_rowHeight = 20;
      this.m_columnHeaderHeight = -1;
      this.m_rowSelectorWidth = 16;
      this.m_horizOffset = 0;
      this.m_clipRect = null;
      this.m_pendingInvalidate = false;
      this.m_dataProvider = null;
      this.m_recordsetProvider = new RecordsetProvider();
      this.m_dataProviderAsyncMessage = 0;
      this.m_editorCurrent = null;
      this.m_editorDefaultWndProc = 0;
      this.m_editorNewWndProc = 0;
      this.m_editorSubclassed = null;
      this.m_trackingResize = false;
      this.m_columnResizing = -1;
      this.m_trackXStart = -1;
      this.m_trackYStart = -1;
      this.m_lastDrawLoc = -1;
      this.m_selection = new Selection();
      this.m_trackingDrag = false;
      this.m_dragColumnStart = -1;
      this.m_dragRowStart = null;
      this.m_dragColumnLast = -1;
      this.m_dragRowLast = null;
      this.m_lastX = -1;
      this.m_lastY = -1;
      this.m_afterColumnEditHandler = null;
      this.m_afterColumnUpdateHandler = null;
      this.m_afterDeleteHandler = null;
      this.m_afterInsertHandler = null;
      this.m_afterUpdateHandler = null;
      this.m_beforeColumnEditHandler = null;
      this.m_beforeColumnUpdateHandler = null;
      this.m_beforeDeleteHandler = null;
      this.m_beforeInsertHandler = null;
      this.m_beforeUpdateHandler = null;
      this.m_changeHandler = null;
      this.m_columnEditHandler = null;
      this.m_columnResizeHandler = null;
      this.m_errorHandler = null;
      this.m_headerClickHandler = null;
      this.m_addNewHandler = null;
      this.m_columnRowChangeHandler = null;
      this.m_rowResizeHandler = null;
      this.m_scrollHandler = null;
      this.m_selChangeHandler = null;
      this.m_validateHandler = null;
      this.m_mouseWheelDelta = 0;
      ((Control)this).setBackColor(Color.WINDOW);
      this.setupBorder();
      ((Control)this).add(this.m_horizScrollbar);
      ((Control)this).add(this.m_vertScrollbar);
      this.m_horizScrollbar.addOnScroll(new ScrollEventHandler(this, "onHorizScroll"));
      this.m_vertScrollbar.addOnScroll(new ScrollEventHandler(this, "onVertScroll"));
      ((Control)this).setTabStop(true);
      this.m_recordsetProvider.setOnAcquireRecordset(new EventHandler(this, "acquireRecordset"));
      this.m_recordsetProvider.setOnReleaseRecordset(new EventHandler(this, "releaseRecordset"));
      this.m_rowSelectorDisplayer.setSize(this.m_rowSelectorWidth, this.m_rowHeight);
      ((Control)this).setBounds(0, 0, 121, 121);
   }

   public int getApproxRowCount() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return this.m_dataProvider.getTotalRowCount();
      }
   }

   public int getColumnCount() {
      return this.m_columnCount;
   }

   public Object getTag() {
      return this.m_tag;
   }

   public void setTag(Object tag) {
      this.m_tag = tag;
   }

   private boolean isCellVisible(GridCell cell) {
      Rectangle inside = new Rectangle(this.getCachedClientInsideRect());
      inside.x += this.getRowSelectorWidth();
      inside.width -= this.getRowSelectorWidth();
      Rectangle bounds = this.getCellBounds(cell);
      return bounds != null ? inside.contains(bounds) : false;
   }

   public void removeColumn(int displayIndex) {
      if (this.m_columnCount > 0) {
         if (displayIndex < 0 || displayIndex >= this.m_columnCount) {
            throw DataGridException.invalidDisplayIndex();
         }

         Column[] newColumns = new Column[this.m_columnCount - 1];
         int newIndex = 0;

         for(int i = 0; i < this.m_columnCount; ++i) {
            if (i != displayIndex) {
               newColumns[newIndex] = this.m_columns[i];
               newColumns[newIndex].internalSetIndex(newIndex);
               ++newIndex;
            }
         }

         this.m_columns = newColumns;
         this.m_columnCount += -1;
         this.doLayout();
         this.invalidate();
      }

   }

   public void onEndOfRecordsetHandler(Object sender, RecordsetEvent event) {
   }

   public void onWillChangeRecordsetHandler(Object sender, RecordsetEvent event) {
   }

   public void onWillMoveHandler(Object sender, RecordsetEvent event) {
      this.removeEditor();
   }

   public Column addColumn(String boundColumnName) {
      if (boundColumnName == null) {
         throw new IllegalArgumentException("Must pass a valid name");
      } else {
         Column[] newColumns = new Column[this.m_columnCount + 1];
         if (this.m_columnCount > 0) {
            System.arraycopy(this.m_columns, 0, newColumns, 0, this.m_columnCount);
         }

         Column addedColumn = new Column(this, boundColumnName);
         addedColumn.m_width = this.m_defaultColumnWidth;
         addedColumn.internalSetIndex(this.m_columnCount);
         newColumns[this.m_columnCount] = addedColumn;
         this.m_columns = newColumns;
         ++this.m_columnCount;
         this.doLayout();
         this.invalidate();
         return addedColumn;
      }
   }

   int computeRowTop(int displayRow) {
      Rectangle inside = this.getCachedClientInsideRect();
      return displayRow * this.m_rowHeight + this.getColumnHeaderHeight();
   }

   protected void onColumnResize(ColumnResizeEvent event) {
      if (this.m_columnResizeHandler != null) {
         this.m_columnResizeHandler.invoke(this, event);
      }

   }

   private void processResize(int resizeOperation, int mouseX, int mouseY) {
      if (this.m_trackingResize) {
         Rectangle inside = this.getCachedClientInsideRect();
         boolean bColumnResize = this.m_columnResizing != -1;
         Graphics g = ((Control)this).createGraphics();
         int nOldRop = Windows.SetROP2(g.getHandle(), 6);
         g.setPen(new Pen(new Color(0, 0, 0), 0, 4));
         if (resizeOperation != -1) {
            if (bColumnResize) {
               g.drawLine(this.m_lastDrawLoc, inside.y, this.m_lastDrawLoc, inside.y + inside.height);
            } else {
               g.drawLine(inside.x, this.m_lastDrawLoc, inside.x + inside.width, this.m_lastDrawLoc);
            }
         }

         if (resizeOperation != -2) {
            if (bColumnResize) {
               this.m_lastDrawLoc = mouseX;
               g.drawLine(this.m_lastDrawLoc, inside.y, this.m_lastDrawLoc, inside.y + inside.height);
            } else {
               this.m_lastDrawLoc = mouseY;
               g.drawLine(inside.x, this.m_lastDrawLoc, inside.x + inside.width, this.m_lastDrawLoc);
            }
         }

         Windows.SetROP2(g.getHandle(), nOldRop);
         if (resizeOperation == -2) {
            if (((Control)this).getCursor() != Cursor.DEFAULT) {
               ((Control)this).setCursor(Cursor.DEFAULT);
            }

            this.m_trackingResize = false;
         }

      }
   }

   public void removeOnRowResize(CancelEventHandler handler) {
      this.m_rowResizeHandler = (CancelEventHandler)Closure.remove(this.m_rowResizeHandler, handler);
   }

   protected void wndProc(Message m) {
      boolean callDefault = true;
      switch (m.msg) {
         case 20:
            Windows.FillRect(m.wParam, this.getCachedResizeBox().toRECT(), this.m_controlBrush.getHandle());
            callDefault = false;
            break;
         case 135:
            callDefault = false;
            m.result = 0;
            if (this.m_allowArrows) {
               m.result |= 1;
            }

            if (this.m_tabAction != 0) {
               m.result |= 2;
            }
            break;
         case 256:
            if (this.m_dataProvider != null && ((Control)this).getEnabled()) {
               switch (m.wParam) {
                  case 46:
                     if (this.m_allowDelete) {
                        this.deleteSelectedRows();
                     }
                     break;
                  default:
                     callDefault = this.processMoveKey(m.wParam);
               }
            }
      }

      if (this.m_dataProviderAsyncMessage != 0 && m.msg == this.m_dataProviderAsyncMessage && this.m_dataProvider != null) {
         this.m_dataProvider.asyncMessageRecieved(m);
      }

      if (callDefault) {
         super.wndProc(m);
      }

   }

   public void setColumnHeaders(boolean columnHeaders) {
      if (this.m_showColumnHeaders != columnHeaders) {
         this.m_showColumnHeaders = columnHeaders;
         this.doLayout();
         this.invalidate();
      }

   }

   protected void onHeaderClick(ColumnEvent event) {
      if (this.m_headerClickHandler != null) {
         this.m_headerClickHandler.invoke(this, event);
      }

   }

   public void refresh() {
      this.invalidate();
   }

   public boolean isColumnHeaders() {
      return this.m_showColumnHeaders;
   }

   public boolean isAllowUpdate() {
      return this.m_allowUpdate;
   }

   protected void onAfterColumnUpdate(ColumnEvent event) {
      if (this.m_afterColumnUpdateHandler != null) {
         this.m_afterColumnUpdateHandler.invoke(this, event);
      }

   }

   public void addOnAfterUpdate(EventHandler handler) {
      this.m_afterUpdateHandler = (EventHandler)Closure.combine(handler, this.m_afterUpdateHandler);
   }

   public void addOnBeforeDelete(CancelEventHandler handler) {
      this.m_beforeDeleteHandler = (CancelEventHandler)Closure.combine(handler, this.m_beforeDeleteHandler);
   }

   public void removeOnBeforeUpdate(CancelEventHandler handler) {
      this.m_beforeUpdateHandler = (CancelEventHandler)Closure.remove(this.m_beforeUpdateHandler, handler);
   }

   private void showEditor() {
      if (this.m_dataProvider != null && this.m_currentColumn != -1 && this.m_currentRowRef != null && this.isCurrentCellVisible()) {
         Column column = this.m_columns[this.m_currentColumn];
         if (!column.isReadOnly() && column.getBoundReadField() != null && column.getBoundWriteField() != null) {
            if (this.m_editorCurrent != null) {
               this.removeEditor();
            }

            BeforeColumnEditEvent coledit = null;
            coledit = new BeforeColumnEditEvent(this.m_currentColumn, 0, false);
            this.onBeforeColumnEdit(coledit);
            if (!coledit.cancel) {
               ICellEditor editor = null;
               Rectangle bounds = null;
               String data = null;
               this.setEditRow(this.m_dataProvider.getCurrentRow());
               editor = column.m_editor;
               Field readField = column.getBoundReadField();
               data = this.m_dataProvider.getFormattedData(this.m_editRowRef, readField);
               bounds = this.getCellBounds(this.m_currentColumn, this.m_currentRowRef);
               this.m_editorCurrent = editor;
               Control winEditor = null;

               try {
                  winEditor = (Control)editor;
               } catch (Exception var9) {
               }

               if (winEditor != null) {
                  winEditor.setBackColor(column.getBackColor());
                  winEditor.setForeColor(column.getForeColor());
               }

               editor.showEditor(this, bounds, data);
               if (winEditor != null) {
                  winEditor.setParent(this);
               }

               Windows.SetFocus(((Control)editor).getHandle());
               this.subclassEditor(editor);
               this.onColumnEdit(new ColumnEvent(this.m_currentColumn));
            }
         }

      }
   }

   private void unsubclassEditor(ICellEditor editor) {
      if (this.m_editorSubclassed != null) {
         if (this.m_editorSubclassed != editor) {
            throw new IllegalArgumentException("Wrong editor to unsubclass");
         }

         Control winEditor = (Control)this.m_editorSubclassed;
         Windows.SetWindowLong(winEditor.getHandle(), -4, this.m_editorDefaultWndProc);
         Root.free(this.m_editorNewWndProc);
         this.m_editorDefaultWndProc = 0;
         this.m_editorNewWndProc = 0;
         this.m_editorSubclassed = null;
      }

   }

   protected void deleteSelectedRows() {
      Debug.assert(this.m_dataProvider != null, "Attempt to delete rows with no provider");
      DataRow[] rows = this.m_selection.getRows();
      if (rows != null) {
         CancelEvent cancel = new CancelEvent(false);
         this.onBeforeDelete(cancel);
         if (!cancel.cancel) {
            this.clearSelection();
            this.m_dataProvider.deleteRows(rows);
            this.onAfterDelete(Event.EMPTY);
         }
      }

   }

   public boolean isAllowArrows() {
      return this.m_allowArrows;
   }

   protected void onBeforeInsert(CancelEvent event) {
      if (this.m_beforeInsertHandler != null) {
         this.m_beforeInsertHandler.invoke(this, event);
      }

   }

   public void removeOnAfterInsert(EventHandler handler) {
      this.m_afterInsertHandler = (EventHandler)Closure.remove(this.m_afterInsertHandler, handler);
   }

   public void addOnScroll(CancelEventHandler handler) {
      this.m_scrollHandler = (CancelEventHandler)Closure.combine(handler, this.m_scrollHandler);
   }

   public void setWrapCellPointer(boolean wrapCellPointer) {
      this.m_wrapCellPointer = wrapCellPointer;
   }

   private void beginColumnRowChange() {
      this.m_lastColumn = this.m_currentColumn;
      this.m_lastRow = this.m_currentRowRef;
      this.m_internalRowReposition = true;
   }

   private void notifyColumnsOfAmbientChange() {
      for(int i = this.m_columnCount - 1; i >= 0; --i) {
         this.m_columns[i].ambientsChanged();
      }

   }

   protected void onChange(Event event) {
      if (this.m_changeHandler != null) {
         this.m_changeHandler.invoke(this, event);
      }

   }

   public void removeOnColumnRowChange(ColumnRowChangeEventHandler handler) {
      this.m_columnRowChangeHandler = (ColumnRowChangeEventHandler)Closure.remove(this.m_columnRowChangeHandler, handler);
   }

   private void calcRowBounds() {
      Debug.assert(this.m_dataProvider != null, "calcRowBounds with no data");
      this.m_displayRowCount = this.m_dataProvider.getPageRowCount();
      if (this.m_displayRowCount < this.m_dataProvider.getPageSize() && this.m_showPhantomRow) {
         this.m_phantomRowDisplayIndex = this.m_displayRowCount++;
      }

   }

   public void invalidate() {
      this.m_pendingInvalidate = true;
      super.invalidate();
   }

   protected void onAfterDelete(Event event) {
      if (this.m_afterDeleteHandler != null) {
         this.m_afterDeleteHandler.invoke(this, event);
      }

   }

   private Rectangle getCachedResizeBox() {
      if (this.m_resizeBoxRect == null) {
         Rectangle garbage = this.getCachedClientRect();
      }

      Debug.assert(this.m_resizeBoxRect != null, "m_resizeBoxRect can't be null");
      return this.m_resizeBoxRect;
   }

   protected void onBeforeColumnUpdate(BeforeColumnUpdateEvent event) {
      if (this.m_beforeColumnUpdateHandler != null) {
         this.m_beforeColumnUpdateHandler.invoke(this, event);
      }

   }

   protected int getRowSelectorWidth() {
      return this.m_showRowSelectors ? this.m_rowSelectorWidth : 0;
   }

   protected void onValidate(CancelEvent event) {
      if (this.m_validateHandler != null) {
         this.m_validateHandler.invoke(this, event);
      }

   }

   public void addOnBeforeUpdate(CancelEventHandler handler) {
      this.m_beforeUpdateHandler = (CancelEventHandler)Closure.combine(handler, this.m_beforeUpdateHandler);
   }

   public void removeOnAfterColumnUpdate(ColumnEventHandler handler) {
      this.m_afterColumnUpdateHandler = (ColumnEventHandler)Closure.remove(this.m_afterColumnUpdateHandler, handler);
   }

   public void removeOnSelChange(CancelEventHandler handler) {
      this.m_selChangeHandler = (CancelEventHandler)Closure.remove(this.m_selChangeHandler, handler);
   }

   public void clearSelection() {
      this.m_selection.clearSelection();
      this.m_selection.updateSelections(this);
   }

   protected Object getTopRow() {
      return this.m_dataProvider.getDisplayRow(0).getBookmark();
   }

   protected int getCompleteRowCount() {
      int nRowCount = 0;
      if (this.m_dataProvider != null) {
         nRowCount = this.m_dataProvider.getTotalRowCount();
         if (this.m_showPhantomRow) {
            ++nRowCount;
         }
      }

      return nRowCount;
   }

   public boolean isRowSelectors() {
      return this.m_showRowSelectors;
   }

   public void setAllowAddNew(boolean allowAddNew) {
      this.m_showPhantomRow = allowAddNew;
   }

   public void addOnAddNew(EventHandler handler) {
      this.m_addNewHandler = (EventHandler)Closure.combine(handler, this.m_addNewHandler);
   }

   public Color getSelectedBackColor() {
      return this.m_selectedBackColor;
   }

   public void setSelectedBackColor(Color color) {
      if (color == null) {
         this.setSelectedBackColor(Color.HIGHLIGHT);
      } else {
         if (!color.equals(this.m_selectedBackColor)) {
            this.m_selectedBackColor = color;
            this.notifyColumnsOfAmbientChange();
            this.invalidate();
         }

      }
   }

   public int getSelectEndRow() {
      return -1;
   }

   protected int getCaptionHeight() {
      if (this.m_caption != null) {
         if (this.m_columnHeaderHeight < 0) {
            this.calcHeaderHeight();
         }

         return this.m_columnHeaderHeight;
      } else {
         return 0;
      }
   }

   protected void onResize(Event e) {
      if (this.m_clientRect != null) {
         int borderWidth = this.m_borderDisplayer.getBorderWidth();
         int borderHeight = this.m_borderDisplayer.getBorderHeight();
         Rectangle right = null;
         Rectangle bottom = null;
         right = new Rectangle(this.m_clientRect.x + this.m_clientRect.width - borderWidth, this.m_clientRect.y, borderWidth, this.m_clientRect.height);
         bottom = new Rectangle(this.m_clientRect.x, this.m_clientRect.y + this.m_clientRect.height - borderHeight, this.m_clientRect.width, borderHeight);
         Rectangle newClientRect = ((Control)this).getClientRect();
         if (newClientRect.width != this.m_clientRect.width) {
            ((Control)this).invalidateRect(right);
            right = new Rectangle(newClientRect.x + newClientRect.width - borderWidth, newClientRect.y, borderWidth, newClientRect.height);
            ((Control)this).invalidateRect(right);
         }

         if (newClientRect.height != this.m_clientRect.height) {
            ((Control)this).invalidateRect(bottom);
            bottom = new Rectangle(newClientRect.x, newClientRect.y + newClientRect.height - borderHeight, newClientRect.width, borderHeight);
            ((Control)this).invalidateRect(bottom);
         }

         ((Control)this).invalidateRect(this.m_resizeBoxRect);
         if (this.m_caption != null) {
            ((Control)this).invalidateRect(this.getCaptionBounds());
         }
      }

      super.onResize(e);
      this.doLayout();
      ((Control)this).invalidateRect(this.m_resizeBoxRect);
   }

   public void addOnColumnResize(ColumnResizeEventHandler handler) {
      this.m_columnResizeHandler = (ColumnResizeEventHandler)Closure.combine(handler, this.m_columnResizeHandler);
   }

   public void setSelectEndRow(int row) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         ;
      }
   }

   public Column[] getColumns() {
      Column[] result = null;
      if (this.m_columnCount > 0) {
         result = new Column[this.m_columnCount];
         System.arraycopy(this.m_columns, 0, result, 0, this.m_columnCount);
      }

      return result;
   }

   public void holdColumns() {
      this.m_holdColumns = true;
   }

   public void setColumns(Column[] columns) {
      Column[] newColumns = null;
      if (columns != null && columns.length > 0) {
         for(int i = 0; i < columns.length; ++i) {
            if (columns[i].m_parent != this) {
               throw DataGridException.invalidColumn();
            }
         }

         newColumns = new Column[columns.length];

         for(int i = 0; i < columns.length; ++i) {
            newColumns[i] = columns[i];
            newColumns[i].internalSetIndex(i);
         }
      }

      this.clearColumns();
      if (newColumns != null) {
         this.m_columns = newColumns;
         this.m_columnCount = newColumns.length;
      }

      this.doLayout();
      this.invalidate();
   }

   public int columnContaining(int x) {
      DataGridLocation loc = new DataGridLocation(this, x, this.getCachedClientRect().y);
      return (loc.m_type & 1) == 1 ? loc.m_column : -1;
   }

   public boolean isAllowRowSizing() {
      return this.m_allowRowSizing;
   }

   public Object rowContaining(int y) {
      DataGridLocation loc = new DataGridLocation(this, this.getCachedClientRect().x, y);
      return (loc.m_type & 2) == 2 ? loc.m_row.getBookmark() : null;
   }

   public void onViewScrolled(boolean offsetValid, int offset) {
      this.calcRowBounds();
      this.updateEditorVerticalPosition();
      this.invalidate();
   }

   private void removeEditor() {
      this.removeEditor(false);
   }

   private void removeEditor(boolean cancelUpdate) {
      if (this.m_editorCurrent != null) {
         String newValue = this.m_editorCurrent.getValue();
         Column currentColumn = this.m_columns[this.m_currentColumn];
         this.unsubclassEditor(this.m_editorCurrent);
         this.m_editorCurrent.hideEditor();
         this.m_editorCurrent = null;
         DataRow editRow = this.m_editRowRef;
         this.setEditRow((DataRow)null);
         if (!cancelUpdate) {
            Field readField = currentColumn.getBoundReadField();
            String oldValue = this.m_dataProvider.getFormattedData(editRow, readField);
            if (!newValue.equals(oldValue)) {
               CancelEvent cancel = new CancelEvent(false);
               BeforeColumnUpdateEvent update = null;
               update = new BeforeColumnUpdateEvent(this.m_currentColumn, oldValue, false);
               this.onBeforeUpdate(cancel);
               this.onBeforeColumnUpdate(update);
               if (!cancel.cancel && !update.cancel) {
                  Field writeField = currentColumn.getBoundWriteField();
                  this.m_dataProvider.setFormattedData(writeField, newValue);
                  this.onAfterUpdate(Event.EMPTY);
                  this.onAfterColumnUpdate(new ColumnEvent(this.m_currentColumn));
               }
            }

            this.onAfterColumnEdit(new ColumnEvent(this.m_currentColumn));
         }
      }

   }

   private void subclassEditor(ICellEditor editor) {
      if (this.m_editorSubclassed != null) {
         this.unsubclassEditor(this.m_editorSubclassed);
      }

      this.m_editorSubclassed = editor;
      Control winEditor = (Control)editor;
      this.m_editorDefaultWndProc = Windows.GetWindowLong(winEditor.getHandle(), -4);
      this.m_editorNewWndProc = Root.alloc(new EditorWindowProc(this));
      Windows.SetWindowLong(winEditor.getHandle(), -4, DllLib.addrOf(this.m_editorNewWndProc));
   }

   public void addOnBeforeInsert(CancelEventHandler handler) {
      this.m_beforeInsertHandler = (CancelEventHandler)Closure.combine(handler, this.m_beforeInsertHandler);
   }

   public boolean isWrapCellPointer() {
      return this.m_wrapCellPointer;
   }

   public void onHorizScroll(Object sender, ScrollEvent se) {
      se.useNewPos = false;
      if (((Control)this).getEnabled()) {
         int nNewHorizOffset = se.newPos;
         this.setHorizOffset(nNewHorizOffset);
      }
   }

   public void scroll(int cols, int rows) {
   }

   public void addOnChange(EventHandler handler) {
      this.m_changeHandler = (EventHandler)Closure.combine(handler, this.m_changeHandler);
   }

   public Font getHeaderFont() {
      return this.m_headerFont != null ? this.m_headerFont : ((Control)this).getFont();
   }

   public void setHeaderFont(Font headerFont) {
      this.m_headerFont = headerFont;
      this.m_captionDisplayer.setFont(this.getHeaderFont());

      for(int i = 0; i < this.m_columnCount; ++i) {
         this.m_columns[i].m_headerDisplayer.setFont(this.getHeaderFont());
      }

      this.m_columnHeaderHeight = -1;
      this.doLayout();
      this.invalidate();
   }

   public int getDefaultColumnWidth() {
      return this.m_defaultColumnWidth;
   }

   private int getTotalWidth() {
      int width = 0;

      for(int i = this.m_columnCount - 1; i >= 0; --i) {
         Column col = this.m_columns[i];
         if (col.isVisible()) {
            width += col.m_width;
         }
      }

      return width;
   }

   public void setDefaultColumnWidth(int width) {
      this.m_defaultColumnWidth = width;
   }

   protected DataProvider getDataProvider() {
      return this.m_dataProvider;
   }

   public int getTabAction() {
      return this.m_tabAction;
   }

   protected void onMouseDown(MouseEvent me) {
      if (this.m_dataProvider != null && ((Control)this).getEnabled()) {
         this.m_lastX = me.x;
         this.m_lastY = me.y;
         DataGridLocation loc = new DataGridLocation(this, me.x, me.y);
         boolean bOverCell = (loc.m_type & 4) == 4;
         boolean bOverColumnHeader = (loc.m_type & 1) == 1;
         boolean bOverRowSelector = (loc.m_type & 2) == 2;
         int nModifier = Control.getModifierKeys();
         boolean bControlDown = (nModifier & 131072) == 131072;
         boolean bShiftDown = (nModifier & 65536) == 65536;
         ((Control)this).focus();
         if (bOverCell) {
            this.m_selection.clearSelection();
            int oldColumn = this.m_currentColumn;
            DataRow oldRow = this.m_currentRowRef;
            this.beginColumnRowChange();
            this.setCurrentColumnRow(loc.m_column, loc.m_row);
            if (!DataProvider.rowsEqual(oldRow, loc.m_row)) {
               this.m_dataProvider.move(loc.m_row);
               this.invalidateRowSelector(oldRow);
               this.invalidateRowSelector(loc.m_row);
            }

            this.endColumnRowChange();
         }

         boolean bColumnResize = (loc.m_type & 131072) == 131072;
         boolean bRowResize = (loc.m_type & 65536) == 65536;
         if (bColumnResize || bRowResize) {
            this.m_trackingResize = true;
            this.m_trackXStart = me.x;
            this.m_trackYStart = me.y;
            if (bColumnResize) {
               this.m_columnResizing = loc.m_column;
            } else {
               this.m_columnResizing = -1;
            }

            this.processResize(-1, me.x, me.y);
         }

         boolean firedSelChange = false;
         boolean cancelSelChange = false;
         if (bOverColumnHeader && !this.m_trackingResize) {
            if (!firedSelChange) {
               cancelSelChange = this.fireSelChangeEvent();
            }

            if (!cancelSelChange) {
               if (this.m_selection.isColumnSelected(loc.m_column) && bControlDown) {
                  this.m_selection.deselectColumn(loc.m_column);
               } else {
                  if (!bControlDown) {
                     this.m_selection.clearSelection();
                  }

                  this.m_selection.selectColumn(loc.m_column);
                  this.setMarqueePosition(new GridCell(this, loc.m_column, this.m_currentRowRef));
               }
            }
         }

         if (bOverRowSelector && !this.m_trackingResize) {
            if (!firedSelChange) {
               cancelSelChange = this.fireSelChangeEvent();
            }

            if (!cancelSelChange) {
               if (this.m_selection.isRowSelected(loc.m_row) && bControlDown) {
                  this.m_selection.deselectRow(loc.m_row);
               } else {
                  if (!bControlDown) {
                     this.m_selection.clearSelection();
                  }

                  this.m_selection.selectRow(loc.m_row);
                  this.m_dataProvider.move(loc.m_row);
               }
            }
         }

         this.m_selection.updateSelections(this);
      }
   }

   public void setTabAction(int action) {
      if (!this.isValidTabAction(action)) {
         throw DataGridException.invalidTabAction();
      } else {
         this.m_tabAction = action;
      }
   }

   private void setupBorder() {
      switch (this.m_borderStyle) {
         case 0:
            this.m_borderDisplayer.setBorderStyle(4);
            break;
         case 1:
            this.m_borderDisplayer.setBorderStyle(1);
            break;
         case 2:
            this.m_borderDisplayer.setBorderStyle(18);
      }

   }

   public int getSelectStartRow() {
      return -1;
   }

   private void invalidateRow(DataRow row, boolean update) {
      if (row != null) {
         Debug.assert(this.m_dataProvider != null, "invalidateRow without data");
         Rectangle bounds = this.getCellBounds(new GridCell(this, this.getFirstVisibleColumn(), row));
         if (bounds != null) {
            Rectangle inside = this.getCachedClientInsideRect();
            bounds.x = inside.x;
            bounds.width = inside.width;
            ((Control)this).invalidateRect(bounds);
            if (update) {
               ((Control)this).update();
            }
         }

      }
   }

   protected boolean fireSelChangeEvent() {
      CancelEvent cancel = new CancelEvent(false);
      this.onSelChange(cancel);
      return cancel.cancel;
   }

   protected boolean fireScrollEvent() {
      CancelEvent cancel = new CancelEvent(false);
      this.onScroll(cancel);
      return cancel.cancel;
   }

   public boolean isCurrentRowModified() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return false;
      }
   }

   private void setEditRow(DataRow row) {
      if (this.m_editRowRef != null) {
         this.invalidateRowSelector(this.m_editRowRef);
      }

      this.m_editRowRef = row;
      if (this.m_editRowRef != null) {
         this.invalidateRowSelector(this.m_editRowRef);
      }

   }

   public void removeOnRowSelectorDraw(RowSelectorDrawEventHandler draw) {
      this.m_rowSelectorDraw = (RowSelectorDrawEventHandler)Closure.remove(this.m_rowSelectorDraw, draw);
      this.invalidate();
   }

   public void setSelectStartRow(int row) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         ;
      }
   }

   private void updateEditorVerticalPosition() {
      if (this.m_editorCurrent != null) {
         Control editorControl = null;

         try {
            editorControl = (Control)this.m_editorCurrent;
         } catch (Exception var5) {
         }

         Rectangle inside = this.getCachedClientInsideRect();
         Rectangle cellBounds = this.getCellBounds(this.m_currentColumn, this.m_editRowRef);
         if (cellBounds == null) {
            cellBounds = new Rectangle(inside.x, inside.y + inside.height, 0, 0);
         } else {
            if (cellBounds.y < inside.y + this.getColumnHeaderHeight()) {
               cellBounds.height += cellBounds.y - (inside.y + this.getColumnHeaderHeight());
               cellBounds.y = inside.y + this.getColumnHeaderHeight();
            }

            if (cellBounds.y + cellBounds.height > inside.y + inside.height) {
               cellBounds.height = inside.y + inside.height - cellBounds.y;
               if (cellBounds.height < 0) {
                  cellBounds.height = 0;
               }
            }
         }

         Rectangle currentBounds = editorControl.getBounds();
         if (cellBounds.x != currentBounds.x || cellBounds.y != currentBounds.y || cellBounds.width != currentBounds.width || cellBounds.height != currentBounds.height) {
            editorControl.setBounds(cellBounds);
         }
      }

   }

   public void removeOnError(ErrorEventHandler handler) {
      this.m_errorHandler = (ErrorEventHandler)Closure.remove(this.m_errorHandler, handler);
   }

   protected int getFirstVisibleColumn() {
      if (this.m_firstVisibleColumn == -1 && this.m_columnCount > 0) {
         for(int i = 0; i < this.m_columnCount; ++i) {
            if (this.m_columns[i].isVisible()) {
               this.m_firstVisibleColumn = i;
               break;
            }
         }
      }

      return this.m_firstVisibleColumn;
   }

   public Column getColumn(int index) {
      if (index >= 0 && index < this.m_columnCount) {
         return this.getInternalColumn(index);
      } else {
         throw DataGridException.invalidDisplayIndex();
      }
   }

   public void onWillChangeFieldHandler(Object sender, RecordsetEvent event) {
   }

   public void onWillChangeRecordHandler(Object sender, RecordsetEvent event) {
   }

   public int getLeftColumn() {
      int leftColumn = -1;
      int left = this.getCachedClientInsideRect().x + this.getRowSelectorWidth();

      for(int i = 0; i < this.m_columnCount; ++i) {
         Column col = this.m_columns[i];
         if (col.isVisible() && col.m_x <= left && col.m_width + col.m_x > left) {
            leftColumn = i;
            break;
         }
      }

      return leftColumn;
   }

   public int getSelectStartColumn() {
      return -1;
   }

   protected void invalidateColumn(int column) {
      if (column >= 0) {
         Column col = this.m_columns[column];
         if (col.isVisible()) {
            Rectangle inside = this.getCachedClientInsideRect();
            ((Control)this).invalidateRect(new Rectangle(col.m_x, inside.y, col.m_width, inside.height));
            ((Control)this).update();
         }

      }
   }

   protected void onMouseMove(MouseEvent me) {
      super.onMouseMove(me);
      boolean readyToHandleMessages = this.m_dataProvider != null && ((Control)this).getEnabled();
      boolean mouseMovedEnough = Math.abs(this.m_lastX - me.x) >= 2 && Math.abs(this.m_lastY - me.y) >= 2;
      if (readyToHandleMessages && mouseMovedEnough) {
         if (!this.m_trackingResize && !this.m_trackingDrag) {
            boolean setMouseCursor = false;
            DataGridLocation loc = new DataGridLocation(this, me.x, me.y);
            Rectangle inside = this.getCachedClientInsideRect();

            for(int i = 0; i < this.m_columnCount; ++i) {
               Column cur = this.m_columns[i];
               if (cur.isVisible()) {
                  boolean bOverHeader = (loc.m_type & 1) == 1;
                  boolean bOverWrongHeader = bOverHeader && i != loc.m_column;
                  boolean bNotOverHeader = !bOverHeader;
                  boolean bOverCorrectHeader = bOverHeader && i == loc.m_column;
                  boolean bOverResize = bOverHeader && (loc.m_type & 131072) == 131072;
                  if (cur.m_headerDisplayer.isMouseOver() && (bOverWrongHeader || bNotOverHeader)) {
                     cur.m_headerDisplayer.setMouseOver(false);
                     ((Control)this).invalidateRect(new Rectangle(cur.m_x, inside.y, cur.m_width, this.getColumnHeaderHeight()));
                     ((Control)this).update();
                  }

                  if (!cur.m_headerDisplayer.isMouseOver() && bOverCorrectHeader) {
                     cur.m_headerDisplayer.setMouseOver(true);
                     ((Control)this).invalidateRect(new Rectangle(cur.m_x, inside.y, cur.m_width, this.getColumnHeaderHeight()));
                     ((Control)this).update();
                  }

                  if (bOverResize) {
                     ((Control)this).setCursor(Cursor.SIZEWE);
                     setMouseCursor = true;
                  }
               }
            }

            boolean bOverCell = (loc.m_type & 4) == 4;
            if (bOverCell) {
               if (!DataProvider.rowsEqual(this.m_hotCell.m_row, loc.m_row) || this.m_hotCell.m_column != loc.m_column) {
                  this.clearHotTrack();
                  this.m_hotCell.m_row = loc.m_row;
                  this.m_hotCell.m_column = loc.m_column;
                  if (loc.getBounds() != null) {
                     ((Control)this).invalidateRect(loc.getBounds());
                  }

                  ((Control)this).update();
               }
            } else {
               this.clearHotTrack();
            }

            boolean bOverRowResize = (loc.m_type & 65536) == 65536;
            if (bOverRowResize) {
               ((Control)this).setCursor(Cursor.SIZENS);
               setMouseCursor = true;
            }

            if (!setMouseCursor && ((Control)this).getCursor() != Cursor.DEFAULT) {
               ((Control)this).setCursor(Cursor.DEFAULT);
            }

         } else {
            this.processResize(-3, me.x, me.y);
            this.processDrag(me.x, me.y);
            super.onMouseMove(me);
         }
      }
   }

   public int rowTop(Object row) {
      if (row == null) {
         throw DataGridException.invalidRowReference();
      } else {
         Rectangle bounds = this.getCellBounds(this.getFirstVisibleColumn(), this.m_dataProvider.getDisplayRow(row));
         return bounds.y;
      }
   }

   public void setLeftColumn(int displayIndex) {
      if (displayIndex >= 0 && displayIndex < this.m_columnCount) {
         int newHorizOffset = 0;

         for(int i = 0; i < displayIndex; ++i) {
            newHorizOffset += this.m_columns[i].m_width + this.m_gridLinesDisplayer.getLineWidth();
         }

         this.setHorizOffset(newHorizOffset);
      } else {
         throw DataGridException.invalidDisplayIndex();
      }
   }

   public void addOnAfterColumnEdit(ColumnEventHandler handler) {
      this.m_afterColumnEditHandler = (ColumnEventHandler)Closure.combine(handler, this.m_afterColumnEditHandler);
   }

   public void addOnHeaderClick(ColumnEventHandler handler) {
      this.m_headerClickHandler = (ColumnEventHandler)Closure.combine(handler, this.m_headerClickHandler);
   }

   public void removeOnBeforeColumnEdit(BeforeColumnEditEventHandler handler) {
      this.m_beforeColumnEditHandler = (BeforeColumnEditEventHandler)Closure.remove(this.m_beforeColumnEditHandler, handler);
   }

   public void setSelectStartColumn(int displayIndex) {
      boolean cancel = this.fireSelChangeEvent();
      if (!cancel) {
         ;
      }
   }

   private boolean isValidScrollbars(int scrollbars) {
      return scrollbars == 0 || (scrollbars & -4) == 0;
   }

   public String[] getErrorText() {
      return null;
   }

   public boolean isAllowDelete() {
      return this.m_allowDelete;
   }

   protected void onBeforeUpdate(CancelEvent event) {
      if (this.m_beforeUpdateHandler != null) {
         this.m_beforeUpdateHandler.invoke(this, event);
      }

   }

   public void setAllowUpdate(boolean allowUpdate) {
      this.m_allowUpdate = allowUpdate;
   }

   public void addOnAfterDelete(EventHandler handler) {
      this.m_afterDeleteHandler = (EventHandler)Closure.combine(handler, this.m_afterDeleteHandler);
   }

   public void addOnBeforeColumnUpdate(BeforeColumnUpdateEventHandler handler) {
      this.m_beforeColumnUpdateHandler = (BeforeColumnUpdateEventHandler)Closure.combine(handler, this.m_beforeColumnUpdateHandler);
   }

   public void addOnValidate(CancelEventHandler handler) {
      this.m_validateHandler = (CancelEventHandler)Closure.combine(handler, this.m_validateHandler);
   }

   public void removeOnAfterUpdate(EventHandler handler) {
      this.m_afterUpdateHandler = (EventHandler)Closure.remove(this.m_afterUpdateHandler, handler);
   }

   public void removeOnBeforeDelete(CancelEventHandler handler) {
      this.m_beforeDeleteHandler = (CancelEventHandler)Closure.remove(this.m_beforeDeleteHandler, handler);
   }

   private void updateVertScrollbar() {
      if (this.m_showVertScrollbar && this.m_dataProvider != null) {
         int pageSize = this.m_dataProvider.getPageSize();
         int totalSize = this.m_dataProvider.getTotalRowCount();
         float currentRatio = this.m_dataProvider.getTopRowRatio();
         if (totalSize > pageSize) {
            this.m_vertScrollbar.setValues(0, totalSize, 1, pageSize, (int)(currentRatio * (float)totalSize));
         } else {
            this.m_vertScrollbar.setValues(0, 1, 1, 1, 0);
         }
      }

   }

   public int getAsyncPostHwnd() {
      return ((Control)this).getHandle();
   }

   private int getScrollbarWidth() {
      return this.m_showVertScrollbar ? this.m_vertScrollbar.getBounds().width : 0;
   }

   protected void onAddNew(Event event) {
      if (this.m_addNewHandler != null) {
         this.m_addNewHandler.invoke(this, event);
      }

   }

   private boolean isValidGridStyle(int style) {
      return style >= 0 && style <= 2;
   }

   private void ensureCellVisible(GridCell cell) {
      Debug.assert(cell != null, "ensureCellVisible called w/ null cell");
      int nLineHeight = this.m_gridLinesDisplayer.getLineHeight();
      int var10000 = this.m_rowHeight + nLineHeight;
      boolean scrollDataProvider = false;
      Rectangle inside = new Rectangle(this.getCachedClientInsideRect());
      Rectangle bounds = this.getCellBounds(cell);
      int columnX = this.m_columns[cell.m_column].getLeft();
      int columnWidth = this.m_columns[cell.m_column].getWidth();
      inside.x += this.getRowSelectorWidth();
      inside.width -= this.getRowSelectorWidth();
      boolean insideValid = inside.width > 0 && inside.height > 0;
      boolean cellPartiallyVisible = bounds != null && !inside.contains(bounds);
      boolean cellNotVisible = bounds == null;
      if (insideValid && (cellPartiallyVisible || cellNotVisible)) {
         int nXOffset = 0;
         int nYOffset = 0;
         if (columnX + columnWidth > inside.x + inside.width) {
            nXOffset = inside.x + inside.width - (columnX + columnWidth);
         } else if (columnX < inside.x) {
            nXOffset = inside.x - columnX;
         }

         if (cellPartiallyVisible) {
            if (bounds.y + bounds.height > inside.y + inside.height || bounds.y < inside.y) {
               scrollDataProvider = true;
            }
         } else {
            scrollDataProvider = true;
         }

         if (nXOffset != 0) {
            this.setHorizOffset(this.m_horizOffset - nXOffset);
         }

         if (scrollDataProvider && cell.m_row != null) {
            this.m_dataProvider.scroll(0, cell.m_row.getBookmark());
         }
      }

   }

   public boolean isCurrentCellVisible() {
      return this.isCellVisible(this.m_marqueeCell);
   }

   private boolean isValidBorderStyle(int style) {
      return style >= 0 && style <= 2;
   }

   public void makeCurrentCellVisible() {
      this.ensureCellVisible(this.m_marqueeCell);
   }

   public String getCaption() {
      return this.m_caption;
   }

   public int getRowHeight() {
      return this.m_rowHeight;
   }

   private boolean isValidEnterAction(int action) {
      return action >= 0 && action <= 2;
   }

   protected int getBottomRow() {
      Debug.assert(this.m_dataProvider != null, "getBottomRow w/o DataProvider");
      if (this.m_displayRowCount < 0) {
         this.calcRowBounds();
      }

      Debug.assert(this.m_displayRowCount >= 0, "Failed to calculate row count");
      return this.m_displayRowCount - 1;
   }

   public void setCaption(String caption) {
      boolean captionStateChanged = false;
      this.m_captionDisplayer.setCaption(caption);
      if (caption != null && caption.length() == 0) {
         caption = null;
      }

      if (this.m_caption == null && caption != null || this.m_caption != null && caption == null) {
         captionStateChanged = true;
      }

      this.m_caption = caption;
      if (captionStateChanged) {
         this.doLayout();
         this.invalidate();
      } else {
         ((Control)this).invalidateRect(this.getCaptionBounds());
      }

   }

   public void setRowHeight(int rowHeight) {
      if (this.m_allowRowSizing) {
         this.setInternalRowHeight(rowHeight);
      }

   }

   public void removeOnAddNew(EventHandler handler) {
      this.m_addNewHandler = (EventHandler)Closure.remove(this.m_addNewHandler, handler);
   }

   public void setRowSelectors(boolean selectors) {
      if (this.m_showRowSelectors != selectors) {
         this.m_showRowSelectors = selectors;
         this.doLayout();
         this.invalidate();
      }

   }

   public boolean isCurrentCellModified() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return false;
      }
   }

   public void rebind() {
      this.m_recordsetProvider.setDataSource(this.m_recordsetProvider.getDataSource());
   }

   public void addOnError(ErrorEventHandler handler) {
      this.m_errorHandler = (ErrorEventHandler)Closure.combine(handler, this.m_errorHandler);
   }

   public String getDataMember() {
      return this.m_recordsetProvider.getDataMember();
   }

   public void setDataMember(String dataMember) {
      this.m_recordsetProvider.setDataMember(dataMember);
   }

   protected void onAfterColumnEdit(ColumnEvent event) {
      if (this.m_afterColumnEditHandler != null) {
         this.m_afterColumnEditHandler.invoke(this, event);
      }

   }

   public void removeOnColumnEdit(ColumnEventHandler handler) {
      this.m_columnEditHandler = (ColumnEventHandler)Closure.remove(this.m_columnEditHandler, handler);
   }

   public void setAllowRowSizing(boolean rowSizing) {
      this.m_allowRowSizing = rowSizing;
   }

   public int getDisplayIndex(Object bookmark) {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return this.m_dataProvider.getDisplayIndexFromBookmark(bookmark);
      }
   }

   public int getVisibleRows() {
      if (this.m_dataProvider == null) {
         throw DataGridException.invalidWithoutDataSource();
      } else {
         return this.m_dataProvider.getPageRowCount();
      }
   }

   public void setAllowArrows(boolean allowArrows) {
      this.m_allowArrows = allowArrows;
   }

   public void onWillViewScroll(Object sender, CancelEvent cancel) {
      cancel.cancel = this.fireScrollEvent();
   }

   public void clearColumns() {
      this.m_columns = null;
      this.m_columnCount = 0;
      this.doLayout();
      this.invalidate();
   }

   public int getVisibleColumns() {
      Rectangle inside = this.getCachedClientInsideRect();
      int left = inside.x;
      int right = inside.x + inside.width;
      int count = 0;

      for(int i = 0; i < this.m_columnCount; ++i) {
         Column col = this.m_columns[i];
         if (col.isVisible() && (col.m_x >= left && col.m_x < right || col.m_x + col.m_width >= left && col.m_x + col.m_width < right)) {
            ++count;
         }
      }

      return count;
   }

   public void onVertScroll(Object sender, ScrollEvent se) {
      se.useNewPos = false;
      if (((Control)this).getEnabled()) {
         boolean updateScrollbar = true;
         DataRow current = this.m_dataProvider.getDisplayRow(0);
         switch (se.type) {
            case 0:
               if (current != null) {
                  this.m_dataProvider.scroll(-1, current.getBookmark());
               } else {
                  this.m_dataProvider.scrollToFirst();
               }
               break;
            case 1:
               if (current != null) {
                  this.m_dataProvider.scroll(1, current.getBookmark());
               } else {
                  this.m_dataProvider.scrollToBottom();
               }
               break;
            case 2:
               if (current != null) {
                  this.m_dataProvider.scroll(-1 * this.m_dataProvider.getPageSize(), current.getBookmark());
               } else {
                  this.m_dataProvider.scrollToFirst();
               }
               break;
            case 3:
               if (current != null) {
                  this.m_dataProvider.scroll(this.m_dataProvider.getPageSize(), current.getBookmark());
               } else {
                  this.m_dataProvider.scrollToBottom();
               }
               break;
            case 4:
               int totalSize = this.m_dataProvider.getTotalRowCount();
               this.m_dataProvider.scroll((float)se.newPos / (float)totalSize);
               break;
            case 5:
               updateScrollbar = false;
         }

         if (updateScrollbar) {
            this.updateVertScrollbar();
         }

      }
   }

   public void addOnRowResize(CancelEventHandler handler) {
      this.m_rowResizeHandler = (CancelEventHandler)Closure.combine(handler, this.m_rowResizeHandler);
   }

   public void removeOnColumnResize(ColumnResizeEventHandler handler) {
      this.m_columnResizeHandler = (ColumnResizeEventHandler)Closure.remove(this.m_columnResizeHandler, handler);
   }

   public void removeOnScroll(CancelEventHandler handler) {
      this.m_scrollHandler = (CancelEventHandler)Closure.remove(this.m_scrollHandler, handler);
   }
}
