package icontrols.DataGrid;

import icontrols.Data.DataProvider;
import icontrols.Data.DataRow;

class SelectionRange {
   public static final int SELTYPE_ROW = 1;
   public static final int SELTYPE_COLUMN = 2;
   public static final int SELTYPE_CELL = 3;
   public SelectionRange m_idealRange = null;
   public DataRow m_topRow = null;
   public int m_leftColumn = -1;
   public DataRow m_bottomRow = null;
   public int m_rightColumn = -1;
   public int m_type = 3;
   public boolean m_dirty = true;
   public DataRow[] m_rows = null;

   public boolean intersectsWith(SelectionRange range) {
      return this.m_type == range.m_type && this.m_type == 3;
   }

   public SelectionRange(int displayIndexOfColumn) {
      this.m_leftColumn = displayIndexOfColumn;
      this.m_rightColumn = displayIndexOfColumn;
      this.m_topRow = null;
      this.m_bottomRow = null;
      this.m_type = 2;
   }

   public SelectionRange(DataRow row) {
      this.m_leftColumn = -1;
      this.m_rightColumn = -1;
      this.m_topRow = row;
      this.m_bottomRow = row;
      this.m_type = 1;
      this.m_rows = new DataRow[]{row};
   }

   public String toString() {
      String sz = this.getClass().getName() + "[";
      switch (this.m_type) {
         case 1:
            sz = sz + "SELTYPE_ROW, ";
            break;
         case 2:
            sz = sz + "SELTYPE_COLUMN, ";
            break;
         case 3:
            sz = sz + "SELTYPE_CELL, ";
      }

      sz = sz + this.m_leftColumn + ", " + this.m_topRow + ", ";
      sz = sz + this.m_rightColumn + ", " + this.m_bottomRow + "]";
      if (this.m_idealRange != null && this.m_idealRange != this) {
         sz = sz + "ideal/" + this.m_idealRange;
      }

      return sz;
   }

   public boolean contains(int columnDisplayIndex, DataRow row) {
      switch (this.m_type) {
         case 1:
            return DataProvider.rowsEqual(this.m_rows[0], row);
         case 2:
            if (columnDisplayIndex != this.m_leftColumn) {
               return false;
            }

            return true;
         case 3:
            return false;
         default:
            return false;
      }
   }

   public boolean isCellInRange(int column, DataRow row) {
      return this.contains(column, row);
   }
}
